unit SAB80535dm;

interface

uses
   Windows, Messages, SysUtils, Classes, StdCtrls,
   Graphics, Controls, Forms, Dialogs, inifiles,
   math, menus, assu, simu, oszu;

{$i sfrdef.pic}
type

   TSAB80535 =
   class(TDataModule)
      procedure   DataModuleCreate(Sender: TObject);
   private
      procedure   ProzClick(Sender: TObject);
   public
   end;

var
   SAB80535: TSAB80535;

implementation

{$R *.DFM}

//---------------------------------------
procedure TSAB80535.prozclick(sender: tobject);
var
   i:       integer;
begin
   tmenuitem(sender).checked := true;
   assf.Proz1.Tag := tmenuitem(sender).tag;
   assf.sim1.Enabled := false;
   While oszf.pm.Items.Count > 1
   do oszf.pm.Items[1].Free;

   for i := low(wrk.sf2p) to high(wrk.sf2p)
   do begin
      wrk.sf2p[i] := 0;
   end;
   for i := low(wrk.pi2i) to high(wrk.pi2i)
   do begin
      wrk.pi2i[i] := 0;
      wrk.pi2s[i] := 0;
      wrk.pi2n[i] := '';
   end;

   wrk.proz := 'SAB80535';
   wrk.clcy :=  12 ;

   wrk.clkt[ $11] :=  2 ;
   wrk.clkt[ $31] :=  2 ;
   wrk.clkt[ $51] :=  2 ;
   wrk.clkt[ $71] :=  2 ;
   wrk.clkt[ $91] :=  2 ;
   wrk.clkt[ $B1] :=  2 ;
   wrk.clkt[ $D1] :=  2 ;
   wrk.clkt[ $F1] :=  2 ;

   wrk.clkt[ $26] :=  1 ;
   wrk.clkt[ $27] :=  1 ;

   wrk.clkt[ $28] :=  1 ;
   wrk.clkt[ $29] :=  1 ;
   wrk.clkt[ $2A] :=  1 ;
   wrk.clkt[ $2B] :=  1 ;
   wrk.clkt[ $2C] :=  1 ;
   wrk.clkt[ $2D] :=  1 ;
   wrk.clkt[ $2E] :=  1 ;
   wrk.clkt[ $2F] :=  1 ;
   wrk.clkt[$24] :=  1 ;
   wrk.clkt[$25] :=  1 ;

   wrk.clkt[ $36] :=  1 ;
   wrk.clkt[ $37] :=  1 ;

   wrk.clkt[ $38] :=  1 ;
   wrk.clkt[ $39] :=  1 ;
   wrk.clkt[ $3A] :=  1 ;
   wrk.clkt[ $3B] :=  1 ;
   wrk.clkt[ $3C] :=  1 ;
   wrk.clkt[ $3D] :=  1 ;
   wrk.clkt[ $3E] :=  1 ;
   wrk.clkt[ $3F] :=  1 ;
   wrk.clkt[$34] :=  1 ;
   wrk.clkt[$35] :=  1 ;

   wrk.clkt[ $1] :=  2 ;
   wrk.clkt[ $21] :=  2 ;
   wrk.clkt[ $41] :=  2 ;
   wrk.clkt[ $61] :=  2 ;
   wrk.clkt[ $81] :=  2 ;
   wrk.clkt[ $A1] :=  2 ;
   wrk.clkt[ $C1] :=  2 ;
   wrk.clkt[ $E1] :=  2 ;

   wrk.clkt[ $56] :=  1 ;
   wrk.clkt[ $57] :=  1 ;

   wrk.clkt[ $58] :=  1 ;
   wrk.clkt[ $59] :=  1 ;
   wrk.clkt[ $5A] :=  1 ;
   wrk.clkt[ $5B] :=  1 ;
   wrk.clkt[ $5C] :=  1 ;
   wrk.clkt[ $5D] :=  1 ;
   wrk.clkt[ $5E] :=  1 ;
   wrk.clkt[ $5F] :=  1 ;
   wrk.clkt[$54] :=  1 ;
   wrk.clkt[$55] :=  1 ;
   wrk.clkt[$B0] :=  2 ;
   wrk.clkt[$82] :=  2 ;
   wrk.clkt[$52] :=  1 ;
   wrk.clkt[$53] :=  2 ;
   wrk.clkt[$B4] :=  2 ;
   wrk.clkt[$B5] :=  2 ;

   wrk.clkt[ $B6] :=  2 ;
   wrk.clkt[ $B7] :=  2 ;

   wrk.clkt[ $B8] :=  2 ;
   wrk.clkt[ $B9] :=  2 ;
   wrk.clkt[ $BA] :=  2 ;
   wrk.clkt[ $BB] :=  2 ;
   wrk.clkt[ $BC] :=  2 ;
   wrk.clkt[ $BD] :=  2 ;
   wrk.clkt[ $BE] :=  2 ;
   wrk.clkt[ $BF] :=  2 ;
   wrk.clkt[$C3] :=  1 ;
   wrk.clkt[$E4] :=  1 ;
   wrk.clkt[$C2] :=  1 ;
   wrk.clkt[$B3] :=  1 ;
   wrk.clkt[$F4] :=  1 ;
   wrk.clkt[$B2] :=  1 ;
   wrk.clkt[$D4] :=  1 ;
   wrk.clkt[$14] :=  1 ;

   wrk.clkt[ $16] :=  1 ;
   wrk.clkt[ $17] :=  1 ;

   wrk.clkt[ $18] :=  1 ;
   wrk.clkt[ $19] :=  1 ;
   wrk.clkt[ $1A] :=  1 ;
   wrk.clkt[ $1B] :=  1 ;
   wrk.clkt[ $1C] :=  1 ;
   wrk.clkt[ $1D] :=  1 ;
   wrk.clkt[ $1E] :=  1 ;
   wrk.clkt[ $1F] :=  1 ;
   wrk.clkt[$15] :=  1 ;
   wrk.clkt[$84] :=  4 ;

   wrk.clkt[ $D8] :=  2 ;
   wrk.clkt[ $D9] :=  2 ;
   wrk.clkt[ $DA] :=  2 ;
   wrk.clkt[ $DB] :=  2 ;
   wrk.clkt[ $DC] :=  2 ;
   wrk.clkt[ $DD] :=  2 ;
   wrk.clkt[ $DE] :=  2 ;
   wrk.clkt[ $DF] :=  2 ;
   wrk.clkt[$D5] :=  2 ;
   wrk.clkt[$A5] := 0;
   wrk.clkt[$04] :=  1 ;

   wrk.clkt[ $6] :=  1 ;
   wrk.clkt[ $7] :=  1 ;

   wrk.clkt[ $8] :=  1 ;
   wrk.clkt[ $9] :=  1 ;
   wrk.clkt[ $A] :=  1 ;
   wrk.clkt[ $B] :=  1 ;
   wrk.clkt[ $C] :=  1 ;
   wrk.clkt[ $D] :=  1 ;
   wrk.clkt[ $E] :=  1 ;
   wrk.clkt[ $F] :=  1 ;
   wrk.clkt[$A3] :=  2 ;
   wrk.clkt[$05] :=  1 ;
   wrk.clkt[$20] :=  2 ;
   wrk.clkt[$10] :=  2 ;
   wrk.clkt[$40] :=  2 ;
   wrk.clkt[$73] :=  2 ;
   wrk.clkt[$30] :=  2 ;
   wrk.clkt[$50] :=  2 ;
   wrk.clkt[$70] :=  2 ;
   wrk.clkt[$60] :=  2 ;
   wrk.clkt[$12] :=  2 ;
   wrk.clkt[$02] :=  2 ;

   wrk.clkt[ $E6] :=  1 ;
   wrk.clkt[ $E7] :=  1 ;

   wrk.clkt[ $E8] :=  1 ;
   wrk.clkt[ $E9] :=  1 ;
   wrk.clkt[ $EA] :=  1 ;
   wrk.clkt[ $EB] :=  1 ;
   wrk.clkt[ $EC] :=  1 ;
   wrk.clkt[ $ED] :=  1 ;
   wrk.clkt[ $EE] :=  1 ;
   wrk.clkt[ $EF] :=  1 ;

   wrk.clkt[ $F6] :=  1 ;
   wrk.clkt[ $F7] :=  1 ;

   wrk.clkt[ $F8] :=  1 ;
   wrk.clkt[ $F9] :=  1 ;
   wrk.clkt[ $FA] :=  1 ;
   wrk.clkt[ $FB] :=  1 ;
   wrk.clkt[ $FC] :=  1 ;
   wrk.clkt[ $FD] :=  1 ;
   wrk.clkt[ $FE] :=  1 ;
   wrk.clkt[ $FF] :=  1 ;
   wrk.clkt[$74] :=  1 ;

   wrk.clkt[ $76] :=  1 ;
   wrk.clkt[ $77] :=  1 ;

   wrk.clkt[ $78] :=  1 ;
   wrk.clkt[ $79] :=  1 ;
   wrk.clkt[ $7A] :=  1 ;
   wrk.clkt[ $7B] :=  1 ;
   wrk.clkt[ $7C] :=  1 ;
   wrk.clkt[ $7D] :=  1 ;
   wrk.clkt[ $7E] :=  1 ;
   wrk.clkt[ $7F] :=  1 ;
   wrk.clkt[$90] :=  2 ;
   wrk.clkt[$A2] :=  1 ;

   wrk.clkt[ $A6] :=  2 ;
   wrk.clkt[ $A7] :=  2 ;

   wrk.clkt[ $A8] :=  2 ;
   wrk.clkt[ $A9] :=  2 ;
   wrk.clkt[ $AA] :=  2 ;
   wrk.clkt[ $AB] :=  2 ;
   wrk.clkt[ $AC] :=  2 ;
   wrk.clkt[ $AD] :=  2 ;
   wrk.clkt[ $AE] :=  2 ;
   wrk.clkt[ $AF] :=  2 ;
   wrk.clkt[$E5] :=  1 ;

   wrk.clkt[ $86] :=  2 ;
   wrk.clkt[ $87] :=  2 ;

   wrk.clkt[ $88] :=  2 ;
   wrk.clkt[ $89] :=  2 ;
   wrk.clkt[ $8A] :=  2 ;
   wrk.clkt[ $8B] :=  2 ;
   wrk.clkt[ $8C] :=  2 ;
   wrk.clkt[ $8D] :=  2 ;
   wrk.clkt[ $8E] :=  2 ;
   wrk.clkt[ $8F] :=  2 ;
   wrk.clkt[$92] :=  2 ;
   wrk.clkt[$F5] :=  1 ;
   wrk.clkt[$75] :=  2 ;
   wrk.clkt[$85] :=  2 ;
   wrk.clkt[$83] :=  2 ;
   wrk.clkt[$93] :=  2 ;
   wrk.clkt[$E0] :=  2 ;
   wrk.clkt[$E2] :=  2 ;
   wrk.clkt[ $E3] :=  2 ;
   wrk.clkt[$F0] :=  2 ;
   wrk.clkt[$F2] :=  2 ;
   wrk.clkt[ $F3] :=  2 ;
   wrk.clkt[$A4] :=  4 ;
   wrk.clkt[$00] :=  1 ;

   wrk.clkt[ $46] :=  1 ;
   wrk.clkt[ $47] :=  1 ;

   wrk.clkt[ $48] :=  1 ;
   wrk.clkt[ $49] :=  1 ;
   wrk.clkt[ $4A] :=  1 ;
   wrk.clkt[ $4B] :=  1 ;
   wrk.clkt[ $4C] :=  1 ;
   wrk.clkt[ $4D] :=  1 ;
   wrk.clkt[ $4E] :=  1 ;
   wrk.clkt[ $4F] :=  1 ;
   wrk.clkt[$44] :=  1 ;
   wrk.clkt[$45] :=  1 ;
   wrk.clkt[$A0] :=  2 ;
   wrk.clkt[$72] :=  2 ;
   wrk.clkt[$42] :=  1 ;
   wrk.clkt[$43] :=  2 ;
   wrk.clkt[$D0] :=  2 ;
   wrk.clkt[$C0] :=  2 ;
   wrk.clkt[$22] :=  2 ;
   wrk.clkt[$32] :=  2 ;
   wrk.clkt[$23] :=  1 ;
   wrk.clkt[$33] :=  1 ;
   wrk.clkt[$03] :=  1 ;
   wrk.clkt[$13] :=  1 ;
   wrk.clkt[$D3] :=  1 ;
   wrk.clkt[$D2] :=  1 ;
   wrk.clkt[$80] :=  2 ;

   wrk.clkt[ $96] :=  1 ;
   wrk.clkt[ $97] :=  1 ;

   wrk.clkt[ $98] :=  1 ;
   wrk.clkt[ $99] :=  1 ;
   wrk.clkt[ $9A] :=  1 ;
   wrk.clkt[ $9B] :=  1 ;
   wrk.clkt[ $9C] :=  1 ;
   wrk.clkt[ $9D] :=  1 ;
   wrk.clkt[ $9E] :=  1 ;
   wrk.clkt[ $9F] :=  1 ;
   wrk.clkt[$94] :=  1 ;
   wrk.clkt[$95] :=  1 ;
   wrk.clkt[$C4] :=  1 ;

   wrk.clkt[ $C6] :=  1 ;
   wrk.clkt[ $C7] :=  1 ;

   wrk.clkt[ $C8] :=  1 ;
   wrk.clkt[ $C9] :=  1 ;
   wrk.clkt[ $CA] :=  1 ;
   wrk.clkt[ $CB] :=  1 ;
   wrk.clkt[ $CC] :=  1 ;
   wrk.clkt[ $CD] :=  1 ;
   wrk.clkt[ $CE] :=  1 ;
   wrk.clkt[ $CF] :=  1 ;
   wrk.clkt[$C5] :=  1 ;

   wrk.clkt[ $D6] :=  1 ;
   wrk.clkt[ $D7] :=  1 ;

   wrk.clkt[ $66] :=  1 ;
   wrk.clkt[ $67] :=  1 ;

   wrk.clkt[ $68] :=  1 ;
   wrk.clkt[ $69] :=  1 ;
   wrk.clkt[ $6A] :=  1 ;
   wrk.clkt[ $6B] :=  1 ;
   wrk.clkt[ $6C] :=  1 ;
   wrk.clkt[ $6D] :=  1 ;
   wrk.clkt[ $6E] :=  1 ;
   wrk.clkt[ $6F] :=  1 ;
   wrk.clkt[$64] :=  1 ;
   wrk.clkt[$65] :=  1 ;
   wrk.clkt[$62] :=  1 ;
   wrk.clkt[$63] :=  2 ;

   for i := 128 To 255
   do wrk.sfrd[i] := false;

   wrk.sfrd[$80] := true;
   wrk.sfrd[$81] := true;
   wrk.sfrd[$82] := true;
   wrk.sfrd[$83] := true;
   wrk.sfrd[$87] := true;
   wrk.sfrd[$88] := true;
   wrk.sfrd[$89] := true;
   wrk.sfrd[$8A] := true;
   wrk.sfrd[$8B] := true;
   wrk.sfrd[$8C] := true;
   wrk.sfrd[$8D] := true;
   wrk.sfrd[$90] := true;
   wrk.sfrd[$98] := true;
   wrk.sfrd[$99] := true;
   wrk.sfrd[$A0] := true;
   wrk.sfrd[$A8] := true;
   wrk.sfrd[$A9] := true;
   wrk.sfrd[$B0] := true;
   wrk.sfrd[$B8] := true;
   wrk.sfrd[$B9] := true;
   wrk.sfrd[$C0] := true;
   wrk.sfrd[$C1] := true;
   wrk.sfrd[$C2] := true;
   wrk.sfrd[$C3] := true;
   wrk.sfrd[$C4] := true;
   wrk.sfrd[$C5] := true;
   wrk.sfrd[$C6] := true;
   wrk.sfrd[$C7] := true;
   wrk.sfrd[$C8] := true;
   wrk.sfrd[$CA] := true;
   wrk.sfrd[$CB] := true;
   wrk.sfrd[$CC] := true;
   wrk.sfrd[$CD] := true;
   wrk.sfrd[$D0] := true;
   wrk.sfrd[$D8] := true;
   wrk.sfrd[$D9] := true;
   wrk.sfrd[$DA] := true;
   wrk.sfrd[$DB] := true;
   wrk.sfrd[$E0] := true;
   wrk.sfrd[$E0] := true;
   wrk.sfrd[$E8] := true;
   wrk.sfrd[$E9] := true;
   wrk.sfrd[$EA] := true;
   wrk.sfrd[$EB] := true;
   wrk.sfrd[$EC] := true;
   wrk.sfrd[$ED] := true;
   wrk.sfrd[$EE] := true;
   wrk.sfrd[$EF] := true;
   wrk.sfrd[$F0] := true;
   wrk.sfrd[$F1] := true;
   wrk.sfrd[$F2] := true;
   wrk.sfrd[$F3] := true;
   wrk.sfrd[$F4] := true;
   wrk.sfrd[$F5] := true;
   wrk.sfrd[$F6] := true;
   wrk.sfrd[$F7] := true;
   wrk.sfrd[$F8] := true;
   wrk.sfrd[$F9] := true;
   wrk.sfrd[$FA] := true;
   wrk.sfrd[$FB] := true;
   wrk.sfrd[$FC] := true;
   wrk.sfrd[$FD] := true;
   wrk.sfrd[$FE] := true;
   wrk.sfrd[$FF] := true;

   wrk.pi2s[ 10 ] :=  10 ;
   wrk.pi2s[ 39 ] :=  39 ;
   wrk.pi2s[ 40 ] :=  40 ;
   wrk.pi2s[ 38 ] :=  38 ;
   wrk.pi2s[ 68 ] :=  68 ;
   wrk.pi2s[ 37 ] :=  37 ;
   wrk.pi2s[ 51 ] :=  51 ;
   wrk.pi2s[ 49 ] :=  49 ;
   wrk.pi2s[ 50 ] :=  50 ;
   wrk.pi2s[ 11 ] :=  11 ;
   wrk.pi2s[ 12 ] :=  12 ;
   wrk.pi2s[ 4 ] :=  4 ;
   wrk.pi2s[ 52 ] := $80;
   wrk.pi2s[ 53 ] := $81;
   wrk.pi2s[ 54 ] := $82;
   wrk.pi2s[ 55 ] := $83;
   wrk.pi2s[ 56 ] := $84;
   wrk.pi2s[ 57 ] := $85;
   wrk.pi2s[ 58 ] := $86;
   wrk.pi2s[ 59 ] := $87;
   wrk.pi2s[ 29 ] := $90;
   wrk.pi2s[ 30 ] := $91;
   wrk.pi2s[ 31 ] := $92;
   wrk.pi2s[ 32 ] := $93;
   wrk.pi2s[ 33 ] := $94;
   wrk.pi2s[ 34 ] := $95;
   wrk.pi2s[ 35 ] := $96;
   wrk.pi2s[ 36 ] := $97;
   wrk.pi2s[ 41 ] := $A0;
   wrk.pi2s[ 42 ] := $A1;
   wrk.pi2s[ 43 ] := $A2;
   wrk.pi2s[ 44 ] := $A3;
   wrk.pi2s[ 45 ] := $A4;
   wrk.pi2s[ 46 ] := $A5;
   wrk.pi2s[ 47 ] := $A6;
   wrk.pi2s[ 48 ] := $A7;
   wrk.pi2s[ 21 ] := $B0;
   wrk.pi2s[ 22 ] := $B1;
   wrk.pi2s[ 23 ] := $B2;
   wrk.pi2s[ 24 ] := $B3;
   wrk.pi2s[ 25 ] := $B4;
   wrk.pi2s[ 26 ] := $B5;
   wrk.pi2s[ 27 ] := $B6;
   wrk.pi2s[ 28 ] := $B7;
   wrk.pi2s[ 1 ] := $E8;
   wrk.pi2s[ 2 ] := $E9;
   wrk.pi2s[ 3 ] := $EA;
   wrk.pi2s[ 5 ] := $EB;
   wrk.pi2s[ 6 ] := $EC;
   wrk.pi2s[ 7 ] := $ED;
   wrk.pi2s[ 8 ] := $EE;
   wrk.pi2s[ 9 ] := $EF;
   wrk.pi2s[ 60 ] := $F8;
   wrk.pi2s[ 61 ] := $F9;
   wrk.pi2s[ 62 ] := $FA;
   wrk.pi2s[ 63 ] := $FB;
   wrk.pi2s[ 64 ] := $FC;
   wrk.pi2s[ 65 ] := $FD;
   wrk.pi2s[ 66 ] := $FE;
   wrk.pi2s[ 67 ] := $FF;

   wrk.roms := 65535 ;
   wrk.rams := 128 ;
   wrk.pins := 68 ;

   wrk.bitg := nil;
   wrk.bitm := nil;
   wrk.sbyt := nil;
   wrk.ssfr := nil;
   wrk.tint := nil;
   wrk.rcpu := nil;

   assf.sim1.enabled := true;

end;

procedure TSAB80535.DataModuleCreate(Sender: TObject);
var
   mi:     tmenuitem;
begin
   mi := tmenuitem.Create(self);
   mi.Caption := 'SAB80535';
   mi.name := mi.caption;
   mi.RadioItem := true;
   mi.GroupIndex := 1;
   mi.Tag := 1;
   mi.onclick := prozclick;
   assf.Proz1.Add(mi);
end;

end.
