unit ass51genu;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,	Controls,
	Forms, Dialogs;

type
	Tass51gen =
	class(TDataModule)
	private		{ Private-Deklarationen}
	public		{ Public-Deklarationen}
		function 	findopc(o, o1, o2, o3: string): byte;
	end;

var
  	ass51gen: 	Tass51gen;

implementation

uses ass51u, assu;

{$R *.DFM}

procedure oamrel(s: string; i: integer);
var
	ad:		TNameTab;
	x:			longint;
begin
	if wrk.pass = 1
	then exit;
	ad := assf.getname(s);
	x := ad.adr - wrk.asec[wrk.isec]	- lopc;
	if (x > 127)
	or (x < -128)
	then assf.errlst('Sprung zu weit', 'R');
	hopc[i] := x and $FF;
end;

procedure oama11(s: string; i: integer);
var
	ai:		integer;
	ad:		TNameTab;
begin
	if wrk.pass = 1
	then exit;
	ai := assf.str2num(s);//assf.getname(s);
	ad.adr := ai;
	//
	if (wrk.asec[wrk.isec] + 3) and $fffff800 <> ad.adr and $fffff800
	then assf.errlst('Sprung zu weit', 'R');

	hopc[i] := ad.adr and $FF;
	ad.adr := ad.adr shr 8;
	hopc[i - 1] := hopc[i - 1] + ad.adr shl 5;
end;

procedure oama16(s: string; i: integer);
var
	ad:		longword;
begin
	if wrk.pass = 1
	then exit;
	ad := assf.str2num(s);
	if ad > wrk.roms // and $ffff0000 > 0
	then assf.errlst('Sprung zu weit', 'R');
	hopc[i] := (ad shr 8) and $FF;
	hopc[i + 1] := ad and $FF;
end;

procedure oamdir(s: string; i: integer);
var
	ad:		longint;
begin
	if wrk.pass = 1
	then exit;
	ad := assf.str2num(s);
	if (ad > 127)
	and not wrk.sfrd[ad]
	then assf.errlst('SFR Byte nicht vorhanden', 'W');
	hopc[i] := ad and $FF;
end;

procedure oambit(s: string; i: integer);
var
	ad:		longint;
begin
	if wrk.pass = 1
	then exit;
	ad := assf.str2num(s);
	if (ad > 127)
	and not wrk.sfrd[ad and $F8]
	then assf.errlst('SFR Byte nicht vorhanden', 'W');
	hopc[i] := ad and $FF;
end;

procedure oamnbt(s: string; i: integer);
var
	ad:		longint;
begin
	if wrk.pass = 1
	then exit;
	ad := assf.str2num(copy(s, 2, 16));
	if (ad > 127)
	and not wrk.sfrd[ad and $F8]
	then assf.errlst('SFR Byte nicht vorhanden', 'W');
	hopc[i] := ad and $FF;
end;

procedure oami16(s: string; i: integer);
var
	ad:		longint;
begin
	if wrk.pass = 1
	then exit;
	ad := assf.str2num(copy(s, 2, 32));
	hopc[i] := (ad shr 8) and $FF;
	hopc[i + 1] := ad and $FF;
end;

procedure oamim8(s: string; i: integer);
var
	ad:		longint;
begin
	if wrk.pass = 1
	then exit;
	ad := assf.str2num(copy(s, 2, 32));
	hopc[i] := ad and $FF;
end;

{###beg excel}
//---------------------------------------
                     // Prozeduren
// mit ass51opc generiert
   
//---------------------------------------
function p1amapd(s: string): boolean;
begin
   p1amapd := false;
   if s = '@A+DPTR'
   then begin
      p1amapd := true;
      exit;
   end;
end;

//---------------------------------------
function p1amapp(s: string): boolean;
begin
   p1amapp := false;
   if s = '@A+PC'
   then begin
      p1amapp := true;
      exit;
   end;
end;

//---------------------------------------
function p1amidp(s: string): boolean;
begin
   p1amidp := false;
   if s = '@DPTR'
   then begin
      p1amidp := true;
      exit;
   end;
end;

//---------------------------------------
function p1amirg(s: string): boolean;
begin
   p1amirg := false;
   if s = '@R0'
   then begin
      p1amirg := true;
      exit;
   end;
   if s = '@R1'
   then begin
//      hopc[0] := hopc[0] + ($1 shl 24);
      p1amirg := true;
      exit;
   end;
end;

//---------------------------------------
function p1amacc(s: string): boolean;
begin
   p1amacc := false;
   if s = 'A'
   then begin
      p1amacc := true;
      exit;
   end;
end;

//---------------------------------------
function p1amaub(s: string): boolean;
begin
   p1amaub := false;
   if s = 'AB'
   then begin
      p1amaub := true;
      exit;
   end;
end;

//---------------------------------------
function p1amcrr(s: string): boolean;
begin
   p1amcrr := false;
   if s = 'C'
   then begin
      p1amcrr := true;
      exit;
   end;
end;

//---------------------------------------
function p1amdpt(s: string): boolean;
begin
   p1amdpt := false;
   if s = 'DPTR'
   then begin
      p1amdpt := true;
      exit;
   end;
end;

//---------------------------------------
function p1amreg(s: string): boolean;
begin
   p1amreg := false;
   if s = 'R0'
   then begin
      p1amreg := true;
      exit;
   end;
   if s = 'R1'
   then begin
//		hopc[0] := hopc[0] + 1;//($1 shl 24);
      p1amreg := true;
      exit;
   end;
   if s = 'R2'
   then begin
//		hopc[0] := hopc[0] + 2;//($2 shl 24);
		p1amreg := true;
		exit;
	end;
	if s = 'R3'
	then begin
//		hopc[0] := hopc[0] + 3;//($3 shl 24);
		p1amreg := true;
		exit;
	end;
	if s = 'R4'
	then begin
//		hopc[0] := hopc[0] + 4;//($4 shl 24);
		p1amreg := true;
		exit;
	end;
	if s = 'R5'
	then begin
//		hopc[0] := hopc[0] + 5;//($5 shl 24);
		p1amreg := true;
		exit;
	end;
	if s = 'R6'
	then begin
//		hopc[0] := hopc[0] + 6;//($6 shl 24);
      p1amreg := true;
      exit;
   end;
   if s = 'R7'
   then begin
//		hopc[0] := hopc[0] + 7;//($7 shl 24);
      p1amreg := true;
      exit;
   end;
end;

//---------------------------------------
function p1ami16(s: string): boolean;
begin
   p1ami16 := false;
   if copy(s, 1, 1) = '#'
   then begin
      p1ami16 := true;
      exit;
   end;
end;

//---------------------------------------
function p1amim8(s: string): boolean;
begin
   p1amim8 := false;
   if copy(s, 1, 1) = '#'
   then begin
      p1amim8 := true;
      exit;
   end;
end;

//---------------------------------------
function p1amdir(s: string): boolean;
begin
   p1amdir := true;
end;

//---------------------------------------
function p1amnbt(s: string): boolean;
begin
   p1amnbt := false;
   if copy(s, 1, 1) = '/'
   then begin
      p1amnbt := true;
      exit;
   end;
end;

//---------------------------------------
function p1ambit(s: string): boolean;
begin
   p1ambit := true;
end;

//---------------------------------------
function p1amrel(s: string): boolean;
begin
   p1amrel := true;
end;

//---------------------------------------
function p1ama11(s: string): boolean;
begin
   p1ama11 := true;
end;

//---------------------------------------
function p1ama16(s: string): boolean;
begin
   p1ama16 := true;
end;

   
//---------------------------------------
function a1amapd(s: string): integer;
begin
   a1amapd :=  0 ;
end;

//---------------------------------------
function a1amapp(s: string): integer;
begin
   a1amapp :=  0 ;
end;

//---------------------------------------
function a1amidp(s: string): integer;
begin
   a1amidp :=  0 ;
end;

//---------------------------------------
function a1amirg(s: string): integer;
begin
   a1amirg :=  0 ;
   if s = '@R1'
   then begin
      hopc[0] := hopc[0] + $1;
      a1amirg :=  0 ;
      exit;
   end;
end;

//---------------------------------------
function a1amacc(s: string): integer;
begin
   a1amacc :=  0 ;
end;

//---------------------------------------
function a1amaub(s: string): integer;
begin
   a1amaub :=  0 ;
end;

//---------------------------------------
function a1amcrr(s: string): integer;
begin
   a1amcrr :=  0 ;
end;

//---------------------------------------
function a1amdpt(s: string): integer;
begin
   a1amdpt :=  0 ;
end;

//---------------------------------------
function a1amreg(s: string): integer;
begin
   a1amreg :=  0 ;
   if s = 'R1'
   then begin
      hopc[0] := hopc[0] + $1;
      a1amreg :=  0 ;
      exit;
   end;
   if s = 'R2'
   then begin
      hopc[0] := hopc[0] + $2;
      a1amreg :=  0 ;
      exit;
   end;
   if s = 'R3'
   then begin
      hopc[0] := hopc[0] + $3;
      a1amreg :=  0 ;
      exit;
   end;
   if s = 'R4'
   then begin
      hopc[0] := hopc[0] + $4;
      a1amreg :=  0 ;
      exit;
   end;
   if s = 'R5'
   then begin
      hopc[0] := hopc[0] + $5;
      a1amreg :=  0 ;
      exit;
   end;
   if s = 'R6'
   then begin
      hopc[0] := hopc[0] + $6;
      a1amreg :=  0 ;
      exit;
   end;
   if s = 'R7'
   then begin
      hopc[0] := hopc[0] + $7;
      a1amreg :=  0 ;
      exit;
   end;
end;

//---------------------------------------
function a1ami16(s: string): integer;
begin
   a1ami16 :=  2 ;
end;

//---------------------------------------
function a1amim8(s: string): integer;
begin
   a1amim8 :=  1 ;
end;

//---------------------------------------
function a1amdir(s: string): integer;
begin
   a1amdir :=  1 ;
end;

//---------------------------------------
function a1amnbt(s: string): integer;
begin
   a1amnbt :=  1 ;
end;

//---------------------------------------
function a1ambit(s: string): integer;
begin
   a1ambit :=  1 ;
end;

//---------------------------------------
function a1amrel(s: string): integer;
begin
   a1amrel :=  1 ;
end;

//---------------------------------------
function a1ama11(s: string): integer;
begin
   a1ama11 :=  1 ;
end;

//---------------------------------------
function a1ama16(s: string): integer;
begin
   a1ama16 :=  2 ;
end;

//---------------------------------------
function Tass51gen.findopc(o, o1, o2, o3: string): byte;
var
   uo1,
   uo2,
   uo3:   string;
begin
   uo1 := uppercase(o1);
   uo2 := uppercase(o2);
   uo3 := uppercase(o3);
   lopc := 1;
	if o = 'ACALL'                      //opcode
	then begin
		if p1ama11(uo1)                  //op1 adress typ
		then begin
			hopc[0] := $11;               //opc
			result := wrk.clkt[$11];      //clocks
			inc(lopc, a1ama11(uo1));
			oama11(o1, 1 );
			exit;
		end;
	end;
	if o = 'ADD'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $26;               //opc
         result := wrk.clkt[$26];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $28;               //opc
         result := wrk.clkt[$28];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $24;               //opc
         result := wrk.clkt[$24];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $25;               //opc
         result := wrk.clkt[$25];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
   end;
   if o = 'ADDC'                       //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $36;               //opc
         result := wrk.clkt[$36];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $38;               //opc
         result := wrk.clkt[$38];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $34;               //opc
         result := wrk.clkt[$34];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $35;               //opc
         result := wrk.clkt[$35];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
   end;
   if o = 'AJMP'                       //opcode
   then begin
      if p1ama11(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $01;               //opc
         result := wrk.clkt[$01];      //clocks
         inc(lopc, a1ama11(uo1));
         oama11(o1, 1 );
         exit;
      end;
   end;
   if o = 'ANL'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $56;               //opc
			result := wrk.clkt[$56];      //clocks
			inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $58;               //opc
         result := wrk.clkt[$58];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $54;               //opc
         result := wrk.clkt[$54];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $55;               //opc
         result := wrk.clkt[$55];      //clocks
         inc(lopc, a1amacc(uo1));
			inc(lopc, a1amdir(uo2));
			oamdir(o2, 1 );
         exit;
      end;
      if p1amcrr(uo1)                  //op1 adress typ
      and p1amnbt(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $B0;               //opc
         result := wrk.clkt[$B0];      //clocks
         inc(lopc, a1amcrr(uo1));
         inc(lopc, a1amnbt(uo2));
         oamnbt(o2, 1 );
         exit;
      end;
      if p1amcrr(uo1)                  //op1 adress typ
      and p1ambit(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $82;               //opc
         result := wrk.clkt[$82];      //clocks
         inc(lopc, a1amcrr(uo1));
         inc(lopc, a1ambit(uo2));
         oambit(o2, 1 );
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $52;               //opc
         result := wrk.clkt[$52];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amacc(uo2));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $53;               //opc
         result := wrk.clkt[$53];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 2 );
         exit;
      end;
	end;
	// ACALL
	if o = 'CALL'                       //opcode
	then begin
		if p1ama11(uo1)                  //op1 adress typ
		then begin
			hopc[0] := $11;               //opc
			result := wrk.clkt[$11];      //clocks
			inc(lopc, a1ama11(uo1));
			oama11(o1, 1 );
			exit;
		end;
	end;
	if o = 'CJNE'                       //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      and p1amrel(uo3)                 //op3 adress typ
      then begin
         hopc[0] := $B4;               //opc
         result := wrk.clkt[$B4];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         inc(lopc, a1amrel(uo3));
         oamrel(o3, 2 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      and p1amrel(uo3)                 //op3 adress typ
      then begin
         hopc[0] := $B5;               //opc
         result := wrk.clkt[$B5];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         inc(lopc, a1amrel(uo3));
         oamrel(o3, 2 );
         exit;
      end;
      if p1amirg(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      and p1amrel(uo3)                 //op3 adress typ
      then begin
         hopc[0] := $B6;               //opc
         result := wrk.clkt[$B6];      //clocks
         inc(lopc, a1amirg(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         inc(lopc, a1amrel(uo3));
         oamrel(o3, 2 );
         exit;
      end;
      if p1amreg(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      and p1amrel(uo3)                 //op3 adress typ
      then begin
         hopc[0] := $B8;               //opc
         result := wrk.clkt[$B8];      //clocks
         inc(lopc, a1amreg(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         inc(lopc, a1amrel(uo3));
         oamrel(o3, 2 );
         exit;
      end;
   end;
   if o = 'CLR'                        //opcode
   then begin
      if p1amcrr(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $C3;               //opc
         result := wrk.clkt[$C3];      //clocks
         inc(lopc, a1amcrr(uo1));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $E4;               //opc
         result := wrk.clkt[$E4];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
      if p1ambit(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $C2;               //opc
         result := wrk.clkt[$C2];      //clocks
         inc(lopc, a1ambit(uo1));
         oambit(o1, 1 );
         exit;
      end;
   end;
   if o = 'CPL'                        //opcode
   then begin
      if p1amcrr(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $B3;               //opc
			result := wrk.clkt[$B3];      //clocks
			inc(lopc, a1amcrr(uo1));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $F4;               //opc
         result := wrk.clkt[$F4];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
      if p1ambit(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $B2;               //opc
         result := wrk.clkt[$B2];      //clocks
         inc(lopc, a1ambit(uo1));
         oambit(o1, 1 );
         exit;
      end;
   end;
   if o = 'DA'                         //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $D4;               //opc
         result := wrk.clkt[$D4];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
   end;
   if o = 'DEC'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $14;               //opc
         result := wrk.clkt[$14];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
      if p1amirg(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $16;               //opc
         result := wrk.clkt[$16];      //clocks
         inc(lopc, a1amirg(uo1));
         exit;
      end;
      if p1amreg(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $18;               //opc
         result := wrk.clkt[$18];      //clocks
         inc(lopc, a1amreg(uo1));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $15;               //opc
         result := wrk.clkt[$15];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         exit;
      end;
   end;
   if o = 'DIV'                        //opcode
   then begin
      if p1amaub(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $84;               //opc
         result := wrk.clkt[$84];      //clocks
         inc(lopc, a1amaub(uo1));
         exit;
      end;
   end;
   if o = 'DJNZ'                       //opcode
   then begin
      if p1amreg(uo1)                  //op1 adress typ
      and p1amrel(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $D8;               //opc
         result := wrk.clkt[$D8];      //clocks
         inc(lopc, a1amreg(uo1));
         inc(lopc, a1amrel(uo2));
         oamrel(o2, 1 );
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amrel(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $D5;               //opc
         result := wrk.clkt[$D5];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amrel(uo2));
         oamrel(o2, 2 );
         exit;
      end;
   end;
   if o = 'EXTOPC'                     //opcode
   then begin
      hopc[0] := $A5;                  //opc
      result := wrk.clkt[$A5];         //clocks
      exit;
   end;
   if o = 'INC'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $04;               //opc
         result := wrk.clkt[$04];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
      if p1amirg(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $06;               //opc
         result := wrk.clkt[$06];      //clocks
         inc(lopc, a1amirg(uo1));
         exit;
      end;
      if p1amreg(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $08;               //opc
         result := wrk.clkt[$08];      //clocks
         inc(lopc, a1amreg(uo1));
         exit;
      end;
      if p1amdpt(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $A3;               //opc
         result := wrk.clkt[$A3];      //clocks
         inc(lopc, a1amdpt(uo1));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $05;               //opc
         result := wrk.clkt[$05];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         exit;
      end;
   end;
   if o = 'JB'                         //opcode
   then begin
      if p1ambit(uo1)                  //op1 adress typ
      and p1amrel(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $20;               //opc
         result := wrk.clkt[$20];      //clocks
         inc(lopc, a1ambit(uo1));
         oambit(o1, 1 );
         inc(lopc, a1amrel(uo2));
         oamrel(o2, 2 );
         exit;
      end;
   end;
   if o = 'JBC'                        //opcode
   then begin
      if p1ambit(uo1)                  //op1 adress typ
      and p1amrel(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $10;               //opc
         result := wrk.clkt[$10];      //clocks
         inc(lopc, a1ambit(uo1));
         oambit(o1, 1 );
         inc(lopc, a1amrel(uo2));
         oamrel(o2, 2 );
         exit;
      end;
   end;
   if o = 'JC'                         //opcode
   then begin
      if p1amrel(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $40;               //opc
         result := wrk.clkt[$40];      //clocks
         inc(lopc, a1amrel(uo1));
         oamrel(o1, 1 );
         exit;
      end;
   end;
   if o = 'JMP'                        //opcode
   then begin
      if p1amapd(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $73;               //opc
         result := wrk.clkt[$73];      //clocks
         inc(lopc, a1amapd(uo1));
         exit;
		end;
		// AJMP
      if p1ama11(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $01;               //opc
         result := wrk.clkt[$01];      //clocks
         inc(lopc, a1ama11(uo1));
         oama11(o1, 1 );
         exit;
      end;
	end;
   if o = 'JNB'                        //opcode
   then begin
      if p1ambit(uo1)                  //op1 adress typ
      and p1amrel(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $30;               //opc
         result := wrk.clkt[$30];      //clocks
         inc(lopc, a1ambit(uo1));
         oambit(o1, 1 );
         inc(lopc, a1amrel(uo2));
         oamrel(o2, 2 );
         exit;
      end;
   end;
   if o = 'JNC'                        //opcode
   then begin
      if p1amrel(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $50;               //opc
         result := wrk.clkt[$50];      //clocks
         inc(lopc, a1amrel(uo1));
         oamrel(o1, 1 );
         exit;
      end;
   end;
   if o = 'JNZ'                        //opcode
   then begin
      if p1amrel(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $70;               //opc
         result := wrk.clkt[$70];      //clocks
         inc(lopc, a1amrel(uo1));
         oamrel(o1, 1 );
         exit;
      end;
   end;
   if o = 'JZ'                         //opcode
   then begin
      if p1amrel(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $60;               //opc
         result := wrk.clkt[$60];      //clocks
         inc(lopc, a1amrel(uo1));
         oamrel(o1, 1 );
         exit;
      end;
   end;
   if o = 'LCALL'                      //opcode
   then begin
      if p1ama16(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $12;               //opc
         result := wrk.clkt[$12];      //clocks
         inc(lopc, a1ama16(uo1));
         oama16(o1, 1 );
         exit;
      end;
   end;
   if o = 'LJMP'                       //opcode
   then begin
      if p1ama16(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $02;               //opc
         result := wrk.clkt[$02];      //clocks
         inc(lopc, a1ama16(uo1));
         oama16(o1, 1 );
         exit;
      end;
   end;
   if o = 'MOV'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $E6;               //opc
         result := wrk.clkt[$E6];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $E8;               //opc
         result := wrk.clkt[$E8];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amirg(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $F6;               //opc
         result := wrk.clkt[$F6];      //clocks
         inc(lopc, a1amirg(uo1));
         inc(lopc, a1amacc(uo2));
         exit;
      end;
      if p1amreg(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $F8;               //opc
         result := wrk.clkt[$F8];      //clocks
         inc(lopc, a1amreg(uo1));
         inc(lopc, a1amacc(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $74;               //opc
         result := wrk.clkt[$74];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amirg(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $76;               //opc
         result := wrk.clkt[$76];      //clocks
         inc(lopc, a1amirg(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amreg(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $78;               //opc
         result := wrk.clkt[$78];      //clocks
         inc(lopc, a1amreg(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amdpt(uo1)                  //op1 adress typ
      and p1ami16(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $90;               //opc
         result := wrk.clkt[$90];      //clocks
         inc(lopc, a1amdpt(uo1));
         inc(lopc, a1ami16(uo2));
         oami16(o2, 1 );
         exit;
      end;
      if p1amcrr(uo1)                  //op1 adress typ
      and p1ambit(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $A2;               //opc
         result := wrk.clkt[$A2];      //clocks
         inc(lopc, a1amcrr(uo1));
         inc(lopc, a1ambit(uo2));
         oambit(o2, 1 );
         exit;
      end;
      if p1amirg(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $A6;               //opc
         result := wrk.clkt[$A6];      //clocks
         inc(lopc, a1amirg(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
      if p1amreg(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $A8;               //opc
         result := wrk.clkt[$A8];      //clocks
         inc(lopc, a1amreg(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $E5;               //opc
         result := wrk.clkt[$E5];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $86;               //opc
         result := wrk.clkt[$86];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $88;               //opc
         result := wrk.clkt[$88];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1ambit(uo1)                  //op1 adress typ
      and p1amcrr(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $92;               //opc
         result := wrk.clkt[$92];      //clocks
         inc(lopc, a1ambit(uo1));
         oambit(o1, 1 );
         inc(lopc, a1amcrr(uo2));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $F5;               //opc
         result := wrk.clkt[$F5];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amacc(uo2));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $75;               //opc
         result := wrk.clkt[$75];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 2 );
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $85;               //opc
         result := wrk.clkt[$85];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 2 );
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
   end;
   if o = 'MOVC'                       //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amapp(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $83;               //opc
         result := wrk.clkt[$83];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amapp(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amapd(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $93;               //opc
         result := wrk.clkt[$93];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amapd(uo2));
         exit;
      end;
   end;
   if o = 'MOVX'                       //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amidp(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $E0;               //opc
         result := wrk.clkt[$E0];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amidp(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $E2;               //opc
         result := wrk.clkt[$E2];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amidp(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $F0;               //opc
         result := wrk.clkt[$F0];      //clocks
         inc(lopc, a1amidp(uo1));
         inc(lopc, a1amacc(uo2));
         exit;
      end;
      if p1amirg(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $F2;               //opc
         result := wrk.clkt[$F2];      //clocks
         inc(lopc, a1amirg(uo1));
         inc(lopc, a1amacc(uo2));
         exit;
      end;
   end;
   if o = 'MUL'                        //opcode
   then begin
      if p1amaub(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $A4;               //opc
         result := wrk.clkt[$A4];      //clocks
         inc(lopc, a1amaub(uo1));
         exit;
      end;
   end;
   if o = 'NOP'                        //opcode
   then begin
      hopc[0] := $00;                  //opc
      result := wrk.clkt[$00];         //clocks
      exit;
   end;
   if o = 'ORL'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $46;               //opc
         result := wrk.clkt[$46];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $48;               //opc
         result := wrk.clkt[$48];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $44;               //opc
         result := wrk.clkt[$44];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $45;               //opc
         result := wrk.clkt[$45];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
      if p1amcrr(uo1)                  //op1 adress typ
      and p1amnbt(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $A0;               //opc
         result := wrk.clkt[$A0];      //clocks
         inc(lopc, a1amcrr(uo1));
         inc(lopc, a1amnbt(uo2));
         oamnbt(o2, 1 );
         exit;
      end;
      if p1amcrr(uo1)                  //op1 adress typ
      and p1ambit(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $72;               //opc
         result := wrk.clkt[$72];      //clocks
         inc(lopc, a1amcrr(uo1));
         inc(lopc, a1ambit(uo2));
         oambit(o2, 1 );
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $42;               //opc
         result := wrk.clkt[$42];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amacc(uo2));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $43;               //opc
         result := wrk.clkt[$43];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 2 );
         exit;
      end;
   end;
   if o = 'POP'                        //opcode
   then begin
      if p1amdir(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $D0;               //opc
         result := wrk.clkt[$D0];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         exit;
      end;
   end;
   if o = 'PUSH'                       //opcode
   then begin
      if p1amdir(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $C0;               //opc
         result := wrk.clkt[$C0];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         exit;
      end;
   end;
   if o = 'RET'                        //opcode
   then begin
      hopc[0] := $22;                  //opc
      result := wrk.clkt[$22];         //clocks
      exit;
   end;
   if o = 'RETI'                       //opcode
   then begin
      hopc[0] := $32;                  //opc
      result := wrk.clkt[$32];         //clocks
      exit;
   end;
   if o = 'RL'                         //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $23;               //opc
         result := wrk.clkt[$23];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
   end;
   if o = 'RLC'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $33;               //opc
         result := wrk.clkt[$33];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
   end;
   if o = 'RR'                         //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $03;               //opc
         result := wrk.clkt[$03];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
   end;
   if o = 'RRC'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $13;               //opc
         result := wrk.clkt[$13];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
   end;
   if o = 'SETB'                       //opcode
   then begin
      if p1amcrr(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $D3;               //opc
         result := wrk.clkt[$D3];      //clocks
         inc(lopc, a1amcrr(uo1));
         exit;
      end;
      if p1ambit(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $D2;               //opc
         result := wrk.clkt[$D2];      //clocks
         inc(lopc, a1ambit(uo1));
         oambit(o1, 1 );
         exit;
      end;
   end;
   if o = 'SJMP'                       //opcode
   then begin
      if p1amrel(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $80;               //opc
         result := wrk.clkt[$80];      //clocks
         inc(lopc, a1amrel(uo1));
         oamrel(o1, 1 );
         exit;
      end;
   end;
   if o = 'SUBB'                       //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $96;               //opc
         result := wrk.clkt[$96];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $98;               //opc
         result := wrk.clkt[$98];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $94;               //opc
         result := wrk.clkt[$94];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $95;               //opc
         result := wrk.clkt[$95];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
   end;
   if o = 'SWAP'                       //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      then begin
         hopc[0] := $C4;               //opc
         result := wrk.clkt[$C4];      //clocks
         inc(lopc, a1amacc(uo1));
         exit;
      end;
   end;
   if o = 'XCH'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $C6;               //opc
         result := wrk.clkt[$C6];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $C8;               //opc
         result := wrk.clkt[$C8];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $C5;               //opc
         result := wrk.clkt[$C5];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
   end;
   if o = 'XCHD'                       //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $D6;               //opc
         result := wrk.clkt[$D6];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
   end;
   if o = 'XRL'                        //opcode
   then begin
      if p1amacc(uo1)                  //op1 adress typ
      and p1amirg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $66;               //opc
         result := wrk.clkt[$66];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amirg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amreg(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $68;               //opc
         result := wrk.clkt[$68];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amreg(uo2));
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $64;               //opc
         result := wrk.clkt[$64];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 1 );
         exit;
      end;
      if p1amacc(uo1)                  //op1 adress typ
      and p1amdir(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $65;               //opc
         result := wrk.clkt[$65];      //clocks
         inc(lopc, a1amacc(uo1));
         inc(lopc, a1amdir(uo2));
         oamdir(o2, 1 );
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amacc(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $62;               //opc
         result := wrk.clkt[$62];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amacc(uo2));
         exit;
      end;
      if p1amdir(uo1)                  //op1 adress typ
      and p1amim8(uo2)                 //op2 adress typ
      then begin
         hopc[0] := $63;               //opc
         result := wrk.clkt[$63];      //clocks
         inc(lopc, a1amdir(uo1));
         oamdir(o1, 1 );
         inc(lopc, a1amim8(uo2));
         oamim8(o2, 2 );
         exit;
      end;
   end;
   findopc := 255;
end;
{###end excel}

end.
