unit oszu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, printers,
  ExtCtrls,
  math, simu, Menus, StdCtrls;

type
	tbcol =
	record
		bgc,										// background color
		vgc,										// foreground color
		lmc,                             // left mark color
		rmc:		TColor;                 // right mark color
		lnc:		array [0..8] of TColor; // line colors
		lef,
		top,
		rig,
		bot:		word;
		hln:		array [0..20] of word;  // hor lines
		hab,                             // hor abstand
		vab,                             // vert abstand
		va1,                             // vert abst 1
		va0:		word;                   // vert abst 0
		cpd:		double;
		cof:		longint;						// offset
	end;

	Toszf =
	class(TForm)
		pb: 			TPaintBox;
		div1: 		TStaticText;
		dbeg: 		TStaticText;
		dpos: 		TStaticText;
		btk0: 		TButton;
		btk1: 		TButton;
		btk2: 		TButton;
		btk3: 		TButton;
		btk4: 		TButton;
		btk5: 		TButton;
		btk6: 		TButton;
		btk7: 		TButton;
		btk8: 		TButton;
		btk9: 		TButton;
		pm: 			TPopupMenu;
    ddif: TStaticText;
	 dlmrk: TStaticText;
	 drmrk: TStaticText;
    mm1: TMainMenu;
    Unit1: TMenuItem;
    usek1: TMenuItem;
    msek1: TMenuItem;
    sek1: TMenuItem;
    cycle1: TMenuItem;
    N1: TMenuItem;
    Reset1: TMenuItem;
    ir1: TMenuItem;
    ext01: TMenuItem;
	 timer01: TMenuItem;
	 ext11: TMenuItem;
    timer11: TMenuItem;
    serial1: TMenuItem;
    timer21: TMenuItem;
    comp1: TMenuItem;
    reti1: TMenuItem;
    Label1: TStaticText;
    Label2: TStaticText;
    Name1: TMenuItem;
    N2: TMenuItem;
    Print1: TMenuItem;
    pd: TPrintDialog;
    otstb: TMenuItem;
    otsth: TMenuItem;
		procedure	pbPaint(Sender: TObject);
		procedure 	FormMouseWheel(Sender: TObject;
							Shift: TShiftState;
							WheelDelta: Integer;
							MousePos: TPoint;
							var Handled: Boolean);
		procedure 	pbMouseMove(Sender: TObject;
							Shift: TShiftState;
							X, Y: Integer);
		procedure 	btkClick(Sender: TObject);
		procedure 	PinClick(Sender: TObject);
		procedure 	pbMouseDown(Sender: TObject;
							Button: TMouseButton;
							Shift: TShiftState;
							X, Y: Integer);
		procedure 	pbMouseUp(Sender: TObject;
							Button: TMouseButton;
							Shift: TShiftState;
							X, Y: Integer);
		procedure 	UnitClick(Sender: TObject);
		procedure 	Reset1Click(Sender: TObject);
		procedure 	irClick(Sender: TObject);
		procedure 	FormCreate(Sender: TObject);
    procedure drmrkClick(Sender: TObject);
    procedure ddifClick(Sender: TObject);
    procedure ddifDblClick(Sender: TObject);
    procedure pmPopup(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure dlmrkMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
	private		{ Private-Deklarationen }
		rep:			boolean;
		procedure 	darst(d: tbcol; c: tcanvas; m: byte);
		procedure 	setbut(kan: byte; but: tbutton);
		procedure 	timeanz(m: byte; lab: TStaticText; wrt: longint);
		function 	timestr(uni: byte; wrt: longint): string;
	public		{ Public-Deklarationen }
		procedure	Rini;
		procedure	Wini;
	end;

var
	wrk:		ptwork;
	oszf: 	Toszf;
	bcol,
	pcol:		tbcol;
	samp:		int64;
	pinf:		file of simu.tpint;
	pinl:		longint;
	lmrk,
	rmrk,
	xbeg:		integer;
	x,
	y:       array [0..63] of integer;
//	cl:      array [0..4] of tcolor;
	b:       array [0..4] of word;
	l:       array [0..4] of word;
	kt:		array [0..10] of int64;
	mdown: 	boolean;
	mpos:		longint;
	cpd:		double;
	cof:		longint;						// offset

implementation

uses assu;

{$R *.DFM}

procedure rbutt(but: tbutton);
begin
//	but.tag := wrk.inif.readinteger('simf', but.name + 'tag', 0);
end;

procedure Toszf.timeanz(m: byte; lab: TStaticText; wrt: longint);
begin
	if m > 1
	then exit;
	case unit1.tag of
//	0:	lab.Caption := format('%6.6x', [wrt * wrk.clcy]);
	0:	lab.Caption := inttostr(wrt * wrk.clcy);
	1:	lab.Caption := format('%3.7f',
						[1 / simf.cpu1.tag * wrt * wrk.clcy]);
	2:	lab.Caption := format('%6.4f',
						[1000 / simf.cpu1.tag * wrt * wrk.clcy]);
	3:	lab.Caption := format('%9.1f',
						[1000000 / simf.cpu1.tag * wrt * wrk.clcy]);
	end;
	if wrt > 0
	then lab.Hint := format('%6.1f', [simf.cpu1.tag / wrt]);
end;

function Toszf.timestr(uni: byte; wrt: longint): string;
begin
	case uni of
	0:	result := inttostr(wrt * wrk.clcy);
	1:	result := format('%3.7f',
						[1 / simf.cpu1.tag * wrt * wrk.clcy]);
	2:	result := format('%6.4f',
						[1000 / simf.cpu1.tag * wrt * wrk.clcy]);
	3:	result := format('%9.1f',
						[1000000 / simf.cpu1.tag * wrt * wrk.clcy]);
	end;
end;

procedure Toszf.Rini;
begin
	assf.RIniForm(Name, Self);
	assf.RIniMenu(Name, unit1);
	assf.RIniMenu(Name, ir1);
	if not assigned(wrk)
	then exit;
	btk0.tag := wrk.inif.ReadInteger(Name, 'btk0pin', 0);
	btk1.tag := wrk.inif.ReadInteger(Name, 'btk1pin', 0);
	btk2.tag := wrk.inif.ReadInteger(Name, 'btk2pin', 0);
	btk3.tag := wrk.inif.ReadInteger(Name, 'btk3pin', 0);
	btk4.tag := wrk.inif.ReadInteger(Name, 'btk4pin', 0);
	btk5.tag := wrk.inif.ReadInteger(Name, 'btk5pin', 0);
	btk6.tag := wrk.inif.ReadInteger(Name, 'btk6pin', 0);
	btk7.tag := wrk.inif.ReadInteger(Name, 'btk7pin', 0);
	btk8.tag := wrk.inif.ReadInteger(Name, 'btk8pin', 0);
	btk9.tag := wrk.inif.ReadInteger(Name, 'btk9pin', 0);
end;

procedure Toszf.Wini;
begin
	assf.WIniForm(Name, Self);
	assf.WIniMenu(Name, unit1);
	assf.WIniMenu(Name, ir1);
	if not assigned(wrk)
	then exit;
	wrk.inif.WriteInteger(Name, 'btk0pin', btk0.tag);
	wrk.inif.WriteInteger(Name, 'btk1pin', btk1.tag);
	wrk.inif.WriteInteger(Name, 'btk2pin', btk2.tag);
	wrk.inif.WriteInteger(Name, 'btk3pin', btk3.tag);
	wrk.inif.WriteInteger(Name, 'btk4pin', btk4.tag);
	wrk.inif.WriteInteger(Name, 'btk5pin', btk5.tag);
	wrk.inif.WriteInteger(Name, 'btk6pin', btk6.tag);
	wrk.inif.WriteInteger(Name, 'btk7pin', btk7.tag);
	wrk.inif.WriteInteger(Name, 'btk8pin', btk8.tag);
	wrk.inif.WriteInteger(Name, 'btk9pin', btk9.tag);
end;

procedure Toszf.darst(d: tbcol; c: tcanvas; m: byte);
var
	s,
	n:			simu.tpint;
	p:			int64;
	i,
	j,
	ib:	  	integer;
	x0,
	y0:		integer;
	fp,
	fd:		longint;
begin
	ib := d.hln[1] - d.hln[0];
	rep := false;
	c.pen.width := 1;
	c.pen.style := pssolid;
	c.brush.color := d.bgc;
	c.Font.Size := c.Font.Size div 2;
	if m = 1
	then begin
		c.fillrect(rect(d.lef, d.top, d.rig, d.bot));
	end
	else begin
		c.pen.color := d.vgc;
		c.Rectangle(rect(d.lef - 3, d.top - 3, d.rig + 3, d.bot + 3))
	end;

	application.ProcessMessages;
	if rep
	then begin
		rep := false;
		exit;
	end;
	c.pen.color := d.vgc;
	c.pen.style := psdot;
	for i := low(x) to high(x)
	do begin
		x[i] := d.lef;
	end;
	for i := low(d.hln) to high(d.hln)
	do begin
		if d.hln[i] = 0
		then break;
		c.moveto(d.lef, d.hln[i]);
		c.lineto(d.rig, d.hln[i]);
	end;
	for i := 1 to 11
	do begin
		y[i] := i * d.vab + d.va1 + d.top;
	end;
	for j := low(b) to high(b)
	do begin
		b[j] := d.top;
	end;
	i := d.lef + d.hab;
	while i < d.rig
	do begin
		c.moveto(i, d.top);
		c.lineto(i, d.bot);
		i := i + d.hab;
	end;

	c.pen.width := m;
	timeanz(m, div1, round(cpd * 64));
	c.pen.style := pssolid;
	ddif.Caption := '';
	dpos.caption := '';
	dlmrk.Caption := '';
	drmrk.caption := '';
	if lmrk > 0
	then begin
		c.pen.color := d.lmc;
		c.moveto(round(d.lef + lmrk / d.cpd - d.cof) + 1, d.top);
		c.lineto(round(d.lef + lmrk / d.cpd - d.cof) + 1, d.bot);
		timeanz(m, dlmrk, lmrk);
		if m > 1
		then printer.Canvas.TextOut(d.lef + round(lmrk / d.cpd - d.cof),
						d.hln[14] + printer.Canvas.TextHeight('H'), 'L');
	end;
	if rmrk > 0
	then begin
		c.pen.color := d.rmc;
		c.moveto(round(d.lef + rmrk / d.cpd - d.cof) + 1, d.top);
		c.lineto(round(d.lef + rmrk / d.cpd - d.cof) + 1, d.bot);
		timeanz(m, drmrk, rmrk);
		if m > 1
		then printer.Canvas.TextOut(d.lef + round(rmrk / d.cpd - d.cof),
						d.hln[14] + printer.Canvas.TextHeight('H'), 'R');
	end;
	if (lmrk > 0) and (rmrk > 0)
	then timeanz(m, ddif, rmrk - lmrk);
	timeanz(m, dbeg, round(d.cof * d.cpd));
	c.pen.color := d.lnc[8];
	assignfile(pinf, changefileext(assf.pc0fnam.Caption, '.pin'));
	reset(pinf);
	// start suchen
	fp := filesize(pinf) div 2;
	fd := fp div 2;
	seek(pinf, fp);
	read(pinf, s);
	x0 := round(s.clck / d.cpd - d.cof) + 1;
	while fd > 0 //sizeof(tpint)
	do begin
		seek(pinf, fp);
		read(pinf, s);
		x0 := round(s.clck / d.cpd - d.cof) + 1;
//		otstb.Caption := format('%6.6x', [s.clck]);
		if x0 = 0
		then break;
		if x0 > 0
		then fp := fp - fd
		else fp := fp + fd;
		fd := fd div 2;
	end;
	while (s.clck > round(d.cof * d.cpd))
	and (fp > 0)
	do begin
		fp := fp - 1; //sizeof(tpint);
		seek(pinf, fp);
		read(pinf, s);
		x0 := round(s.clck / d.cpd - d.cof) + 1;
	end;
//	otsth.Caption := format('%6.6x', [s.clck]);

	p := s.pins;
	for i := 0 to 10
	do begin
		if (p and kt[i]) > 0
		then y[i] := i * d.vab + d.va1 + d.top
		else y[i] := i * d.vab + d.va0 + d.top;
	end;
	n.clck := 1;
	while not eof(pinf)
	do begin
		application.ProcessMessages;
		if rep
		then begin
			closefile(pinf);
			rep := false;
			exit;
		end;
		read(pinf, s);
		x0 := round(s.clck / d.cpd - d.cof) + 1;
		p := s.pins;
		if x0 < d.lef
		then begin
			xbeg := x0;
			for i := 0 to 10
			do begin
				x[i] := x0;
				if (p and kt[i]) > 0
				then y[i] := i * d.vab + d.va1 + d.top
				else y[i] := i * d.vab + d.va0 + d.top;
			end;
			continue;
		end;
		if (s.intl > 0)
		then begin
			for j := 4 downto 1
			do begin
				if b[j] > d.top
				then begin
					c.moveto(x[0], b[j]);
					c.pen.Color := d.lnc[(b[j] + 6) mod 8];
					c.lineto(min(d.rig, max(x0, x[0]+3)), b[j]);
					if s.intl = 7
					then b[j] := d.top;
					break;
				end;
			end;
			for j := 4 downto 1
			do begin
				if b[j] > d.top
				then begin
					x[0] := x0;
					break;
				end;
			end;
			if (s.intl > 7)
			then begin
				if s.intl mod 8 > 6
				then begin
					continue;
				end;
				if (ir1.Items[6 - (s.intl mod 8)].Checked)
				then begin
					x[0] := x0;
					b[s.intl div 8] := d.top + ib * 5
										- s.intl * (ib div 8);
					if m > 1
					then c.TextOut(min(d.rig, max(x0, x[0]+3)),
										b[s.intl div 8],
										inttostr(6 - (s.intl mod 8)));
				end;
			end;
		end;
		c.pen.color := d.lnc[8];
		for i := 1 to 10
		do begin
			if kt[i] > 1
			then begin
				if (p and kt[i]) > 0
				then y0 := i * d.vab + d.va1 + d.top
				else y0 := i * d.vab + d.va0 + d.top;
				if eof(pinf)
				or (x0 > d.rig)
				then begin
					c.MoveTo(x[i], y[i]);
					c.LineTo(min(x0, d.rig), y[i]);
					c.LineTo(min(x0, d.rig), y0);
					continue;
				end;
				if (y0 <> y[i])
				then begin
					c.MoveTo(x[i], y[i]);
					c.LineTo(x0, y[i]);
					c.LineTo(x0, y0);
					x[i] := x0;
					y[i] := y0;
				end;
			end;
		end;
		if x0 > d.rig
		then begin
			for j := 1 to 4
			do begin
				if b[j] > d.top
				then begin
					c.moveto(x[0], b[j]);
					c.pen.Color := d.lnc[(b[j] + 6) mod 8];
					c.lineto(min(d.rig, x[0]), b[j]);
					b[j] := d.top;
					break;
				end;
			end;
			break;
		end;
		s := n;
	end;
	closefile(pinf);
end;

procedure Toszf.pbPaint(Sender: TObject);
begin
	bcol.cpd := cpd;
	bcol.cof := cof;
	darst(bcol, pb.canvas, 1);
end;

procedure Toszf.FormMouseWheel(Sender: TObject;
	Shift: TShiftState;
	WheelDelta: Integer;
	MousePos: TPoint;
	var Handled: Boolean);
var
	p:			double;
begin
	p := dpos.tag * cpd + cof * cpd;
	if wheeldelta < 0
	then cpd := min(2097152, cpd * 2);
	if wheeldelta > 0
	then cpd := max(1, cpd / 2);
	cof := max(0, round((p - dpos.tag * cpd) / cpd));
	pb.repaint;
	handled := true;
end;

var
	bhint:		string;

procedure Toszf.btkClick(Sender: TObject);
var
	p:			tpoint;
begin
	with sender as tbutton
	do begin
		p := clienttoscreen(point(tbutton(sender).width, 0));
		pm.Popup(p.x, p.y);
		application.ProcessMessages;
		kt[taborder + 1] := 1 shl pm.tag;
		tag := pm.tag;
		if pm.tag = 0
		then begin
			caption := '-';
			showhint := false;
		end
		else begin
			if wrk.pi2n[pm.tag] > ''
			then begin
				caption := wrk.pi2n[pm.tag];
				Hint := bhint;
				showhint := true;
			end
			else begin
				caption := bhint;
				showhint := false;
			end
		end;
	end;
	pb.repaint;
end;

procedure Toszf.PinClick(Sender: TObject);
begin
	pm.Tag := tmenuitem(sender).tag;
	bhint := tmenuitem(sender).caption;
end;

procedure Toszf.pbMouseDown(Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
begin
   mdown := true;
	mpos := x;
end;

procedure Toszf.pbMouseMove(Sender: TObject;
			Shift: TShiftState;
			X, Y: Integer);
begin
	if mdown
	then begin
		cof := max(0, dpos.tag - x + cof);
	end;
	dpos.Tag := x;
	timeanz(1, dpos, round(dpos.tag * cpd + cof * cpd));
end;

procedure Toszf.pbMouseUp(Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
begin
	mdown := false;
	if x = mpos
	then begin
		if button = mbleft
		then lmrk := round(mpos * cpd + cof * cpd)
		else rmrk := round(mpos * cpd + cof * cpd);
	end;
	pb.repaint;
end;

procedure Toszf.UnitClick(Sender: TObject);
begin
	tmenuitem(sender).checked := true;
	unit1.caption := 'Unit=' + tmenuitem(sender).caption;
	unit1.tag := tmenuitem(sender).tag;
	pb.repaint;
end;

procedure Toszf.Reset1Click(Sender: TObject);
var
	s:			simu.tpint;
begin
	rep := true;
	cof := 0;
//	lmrk := 0;
	assignfile(pinf, changefileext(assf.pc0fnam.Caption, '.pin'));
	reset(pinf);
	if filesize(pinf) > 16
	then seek(pinf, filesize(pinf) - 1);
	read(pinf, s);
	pinl := s.clck;
	cpd := pinl div pb.width + 2;
	closefile(pinf);
	pb.repaint;
end;

procedure Toszf.irClick(Sender: TObject);
begin
	with sender as tmenuitem
	do begin
		checked := checked xor true;
	end;
	pb.repaint;
end;

procedure Toszf.FormCreate(Sender: TObject);
var
	i:			integer;
begin
	inherited;
	bcol.lnc[0] := clred;
	bcol.lnc[1] := clyellow;
	bcol.lnc[2] := cllime;
	bcol.lnc[3] := claqua;
	bcol.lnc[4] := clwhite;
	bcol.lnc[5] := clfuchsia;
	bcol.lnc[6] := clteal;
	bcol.lnc[7] := bcol.bgc;
	bcol.lnc[8] := cllime;
	cpd := 1;
	bcol.lef := 0;
	bcol.rig := pb.width;
	bcol.top := 0;
	bcol.bot := pb.Height;
	bcol.bgc := clblack;
	bcol.vgc := clgreen;
	bcol.lmc := clwhite;
	bcol.rmc := clred;
	bcol.hln[0] := 9;
	bcol.hln[1] := 17;
	bcol.hln[2] := 25;
	bcol.hln[3] := 33;
	bcol.hab := 64;
	bcol.vab := 24;
	bcol.va1 := bcol.vab div 2 + 3;
	bcol.va0 := bcol.va1 + bcol.vab - 6;
	for i := 1 to 11
	do begin
		bcol.hln[i + 3] := i * bcol.vab + bcol.vab div 2;
	end;
	bcol.hln[15] := 0;
	pcol.bgc := clwhite;
	pcol.vgc := clblack;
	pcol.lmc := cllime;
	pcol.rmc := clred;
	for i := low(pcol.lnc) to high(pcol.lnc)
	do begin
		pcol.lnc[i] := clblack;
	end;
	pcol.top := 200;
	pcol.lef := 300;
end;

procedure Toszf.drmrkClick(Sender: TObject);
begin
	rep := true;
	cof := max(0, round(rmrk / cpd) - pb.Width div 2);
	if cof < 0
	then cof := 0;
	pb.Repaint;
end;

procedure Toszf.ddifClick(Sender: TObject);
begin
	rep := true;
	cpd := max(1, abs(lmrk - rmrk) / (pb.Width - 8) * 2);
	cof := max(0, round(min(lmrk, rmrk) / cpd)) - pb.Width div 4;
	if cof < 0
	then cof := 0;
	pb.Repaint;
end;

procedure Toszf.ddifDblClick(Sender: TObject);
begin
	rep := true;
	cpd := max(1,abs(lmrk - rmrk) / (pb.Width - 8));
	cof := max(0, round(min(lmrk, rmrk) / cpd)) - 2;
	if cof < 0
	then cof := 0;
	pb.Repaint;
end;

procedure Toszf.pmPopup(Sender: TObject);
var
	i:			integer;
begin
	for i := 1 to pm.Items.Count - 1
	do begin
		if wrk.pi2n[pm.Items[i].Tag] > ''
		then pm.Items[i].Caption :=
				format('Pin %d - %s',
					[pm.Items[i].Tag, wrk.pi2n[pm.Items[i].Tag]])
		else pm.Items[i].Caption :=
				format('Pin %d', [pm.Items[i].Tag]);
	end;
end;

procedure Toszf.setbut(kan: byte; but: tbutton);
begin
	if but.Tag = 0
	then begin
		but.Caption := '-';
		kt[kan] := 0;
	end
	else begin
		if wrk.pi2n[but.tag] > ''
		then but.Caption := wrk.pi2n[but.tag]
		else but.Caption := 'Pin ' + inttostr(but.tag);
		kt[kan] := 1 shl but.tag;
	end;
end;

procedure Toszf.FormActivate(Sender: TObject);
begin
	setbut(1, btk0);
	setbut(2, btk1);
	setbut(3, btk2);
	setbut(4, btk3);
	setbut(5, btk4);
	setbut(6, btk5);
	setbut(7, btk6);
	setbut(8, btk7);
	setbut(9, btk8);
	setbut(10, btk9);
	pb.Invalidate;
end;

procedure Toszf.Print1Click(Sender: TObject);
const
	f:	string = '%-20s   %15s   %15s   %15s   %15s';
var
	i:			integer;
	u:			single;
	zz,
	zp:		word;
	br:		word;
	wrt:		integer;
	dci:		integer;
	s:			string;
begin
	// pcol versorgen
	if pd.Execute
	then begin
		printer.Orientation := poLandscape;
		printer.Canvas.Font := assf.pc1lst.Font;
		printer.Canvas.Font.Size := 10;
		pcol.lef := printer.Canvas.TextWidth('aaaaaaaa');
		br := printer.PageWidth div 800;
		pcol.rig := printer.PageWidth - br;
		u := (pcol.rig - pcol.lef) / pb.width;
		for i := low(pcol.hln) to high(pcol.hln)
		do begin
			if bcol.hln[i] > 0
			then begin
				pcol.hln[i] := round(24 * u * i) + pcol.top;
				pcol.bot := pcol.hln[i] + 1;
			end;
		end;
		pcol.vab := round(bcol.vab * u);
		pcol.hab := round(bcol.hab * u);
		pcol.va1 := round(bcol.va1 * u);
		pcol.va0 := round(bcol.va0 * u);
		pcol.va1 := 3 * pcol.vab + br * 2;
		pcol.va0 := 4 * pcol.vab - br * 2;

		pcol.cpd := cpd / u;
		pcol.cof := round(cof * u);						// offset
		printer.BeginDoc;
		printer.Canvas.TextOut(0, pcol.hln[0], 'Int p4');
		printer.Canvas.TextOut(0, pcol.hln[1], 'Int p3');
		printer.Canvas.TextOut(0, pcol.hln[2], 'int p2');
		printer.Canvas.TextOut(0, pcol.hln[3], 'Int p1');
		printer.Canvas.TextOut(0, pcol.hln[4], btk0.Caption);
		printer.Canvas.TextOut(0, pcol.hln[5], btk1.Caption);
		printer.Canvas.TextOut(0, pcol.hln[6], btk2.Caption);
		printer.Canvas.TextOut(0, pcol.hln[7], btk3.Caption);
		printer.Canvas.TextOut(0, pcol.hln[8], btk4.Caption);
		printer.Canvas.TextOut(0, pcol.hln[9], btk5.Caption);
		printer.Canvas.TextOut(0, pcol.hln[10], btk6.Caption);
		printer.Canvas.TextOut(0, pcol.hln[11], btk7.Caption);
		printer.Canvas.TextOut(0, pcol.hln[12], btk8.Caption);
		printer.Canvas.TextOut(0, pcol.hln[13], btk9.Caption);
		zz := pcol.bot + printer.Canvas.TextHeight('H') * 3;
		zp := abs(printer.canvas.font.height);
		s := '';
		for i := 0 to ir1.Count - 1
		do begin
			if ir1.Items[i].Checked
			then s := s + ir1.items[i].caption
							+ '(' + inttostr(i)
							+ '), ';
		end;
		if s > ''
		then delete(s, length(s) - 1, 2);
		printer.Canvas.TextOut(pcol.lef, zz,
						'angez. Interrupts: ' + s);
		inc(zz, zp * 2);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ simf.cpu1.caption + ' Hz',
							'sek',
							'msek',
							'sek',
							'clock']));
		inc(zz, zp * 2);
		wrt := round(cof * cpd);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ 'Fenster Beginn',
							timestr(3, wrt),
							timestr(2, wrt),
							timestr(1, wrt),
							timestr(0, wrt)]));
		inc(zz, zp);
		wrt := round((cof + pb.width) * cpd);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ 'Fenster Ende',
							timestr(3, wrt),
							timestr(2, wrt),
							timestr(1, wrt),
							timestr(0, wrt)]));
		inc(zz, zp);
		wrt := round(cpd * 64);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ '/div',
							timestr(3, wrt),
							timestr(2, wrt),
							timestr(1, wrt),
							timestr(0, wrt)]));
		inc(zz, zp);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ 'linke Marke',
							timestr(3, lmrk),
							timestr(2, lmrk),
							timestr(1, lmrk),
							timestr(0, lmrk)]));
		inc(zz, zp);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ 'Differenz',
							timestr(3, rmrk - lmrk),
							timestr(2, rmrk - lmrk),
							timestr(1, rmrk - lmrk),
							timestr(0, rmrk - lmrk)]));
		inc(zz, zp);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ 'rechte Marke',
							timestr(3, rmrk),
							timestr(2, rmrk),
							timestr(1, rmrk),
							timestr(0, rmrk)]));
		inc(zz, zp * 2);
		printer.Canvas.TextOut(pcol.lef, zz,
			format(f, [ 'Datum',
							datetostr(date),
							timetostr(time),
							'',
							'']));
		darst(pcol, printer.canvas, br);
		printer.EndDoc;
	end;
end;

procedure Toszf.dlmrkMouseDown(Sender: TObject;
	Button: TMouseButton;
	Shift: TShiftState;
	X, Y: Integer);
begin
	if Button = mbleft
	then begin
		rep := true;
		cof := max(0, round(lmrk / cpd) - pb.Width div 2);
		pb.Repaint;
	end;
	if Button = mbright
	then begin
		wrk.scom := lmrk;
	end;
end;

end.
