unit ass51u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs;

type
	Tass51d =
	class(TDataModule)
	private		{ Private-Deklarationen}
	public		{ Public-Deklarationen}
		function pass12: boolean;
	end;

var
	ass51d: 	Tass51d;
	pnum:		array [0..127] of byte;
	cadr:		longint;				// ->	current adresse
	aadr:		longint;				//<-		set adresspegel abs
	lopc:		byte;					//<-   	Lnge des befehls
	cycl:		byte;					//<-    Anzahl cycles
	rcha:		char;					//<-    zeichen
	hopc:		array [0..127]
				of byte; 			//<-		hex code
	o0,
	o1,
	o2,
	o3:		word;
	po1,
	po2,
	po3:		^byte;
	ac:		word;
	zadr:		longint;

implementation

uses assu, ass51genu, assoptu;

{$R *.DFM}

procedure setht(b: byte);
begin
	wrk.prog[wrk.tabi] := b;
	wrk.brtr[wrk.tabi] := byteu;
	if assu.brsw
	then wrk.brtr[wrk.asec[wrk.isec]] :=
				wrk.brtr[wrk.asec[wrk.isec]] or byteb;
	if assu.trosw
	then begin
		wrk.brtr[wrk.asec[wrk.isec]] :=
				wrk.brtr[wrk.asec[wrk.isec]] or byteo;
		assu.trosw := false;
	end;
	if assu.trfsw
	then begin
		wrk.brtr[wrk.asec[wrk.isec]] :=
				wrk.brtr[wrk.asec[wrk.isec]] or bytef;
		assu.trfsw := false;
	end;
	inc(wrk.tabi);
end;

function Tass51d.pass12: boolean;
var
	w:       string;
	n,
	lab,
	opc,
	o1,
	o2,
	o3,
	za,
	zc,
	zi,
	zo,
	x:			string;
	i,
	j,
	k,
	l:			integer;
	zw:		word;
	bsi:		byte;
begin
	result := true;
	with Tass51d
	do begin
		lab := '';
		opc := '';
		o1 := '';
		o2 := '';
		o3 := '';
		n := '';
		lopc := 0;

		if length(wrk.toob) = 0
		then exit;
		x := wrk.tall;
		w := wrk.toob;
		//label extrahieren
		lab := assf.getstring(w, 1);
		if pos(':', lab) > 0
		then lab := copy(lab, 1, pos(':', lab) - 1);
		zi := '';
		if wrk.incl > 0
		then zi := inttostr(wrk.incl);
		
		//opc extrahieren
		opc := uppercase(assf.getstring(w, 2));
		if (opc = '')
		and (lab > '')
		then begin
			if wrk.pass = 1
			then assf.putname(lab, atadr, 0, wrk.asec[wrk.isec]);
			za := format('%4.4x', [wrk.asec[wrk.isec] and $FFFF]);
			if wrk.pass = 2
			then begin
				assf.addlstz(format(znor ,
						[za, '', '', wrk.fnum, wrk.flin, zi])
						+ x);
				dbg.Add(format('%s=C%4.4x', [lab, wrk.asec[wrk.isec]]));
				end;
			exit;
		end;
		//ope extrahieren
		o1 := assf.getstring(w, 3);
		o2 := assf.getstring(w, 4);
		o3 := assf.getstring(w, 5);

		bsi := ass51gen.findopc(opc, o1, o2, o3);
		if (bsi > 0)
		and (bsi < 255)
		then begin
			wrk.attr := tanor;
			if (length(lab) > 0)
			and (wrk.pass = 1)
			then begin
				assf.putname(lab, atcde, 0, wrk.asec[wrk.isec]);
			end;
			wrk.tabi := wrk.asec[wrk.isec];
			if wrk.tabl > wrk.tabi
			then wrk.tabl := wrk.tabi;
			za := format('%4.4x', [wrk.asec[wrk.isec] and $FFFF]);
			if cycl > 0
			then zc := '[' + inttostr(cycl) + ']'
			else zc := '';
			zc := '[' + inttostr(wrk.clkt[hopc[0]]) + ']';
			zi := '';
			if wrk.incl > 0
			then zi := inttostr(wrk.incl);
			j := 0;
			l := lopc;
			while l > 4
			do begin
				zo := format('%2.2x',[hopc[j]]);
				setht(hopc[j]);
				inc(j);
				dec(l);
				for k := 2 to 4
				do begin
					zo := zo + format('%2.2x', [hopc[j]]);
					setht(hopc[j]);
					inc(j);
					dec(l);
				end;
				if wrk.pass = 2
				then assf.addlstz(format(znor ,
								[za, zo, zc, wrk.fnum, wrk.flin, zi])
								+ x);
				za := '';
				x := '';
				zo := '';
			end;
			while l > 0
			do begin
				zo := zo + format('%2.2x', [hopc[j]]);
				setht(hopc[j]);
				inc(j);
				dec(l);
			end;
			if wrk.tabh < wrk.tabi
			then wrk.tabh := wrk.tabi;
			if wrk.pass = 2
			then assf.addlstz(format(znor ,
							[za, zo, zc, wrk.fnum, wrk.flin, zi])
							+ x);
			inc(wrk.asec[wrk.isec], lopc);
			if wrk.asec[wrk.isec] > wrk.hsec[wrk.isec]
			then wrk.hsec[wrk.isec] := wrk.asec[wrk.isec];
			exit;
		end
		else begin
			if uppercase(opc) = 'EQU' //# variabel
			then begin
				wrk.attr := taequ;
				cycl := 0;
				lopc := 0;
				aadr := 0;
				aadr := assf.str2num (o1);
				if (length(lab) > 0)
				and (wrk.pass > 0)
				then begin
					assf.putname(lab, atequ, 0, aadr);
				end;
				za := '';
				zo := format('%8.8x', [aadr]);
				if wrk.pass = 2
				then begin
					assf.addlstz(format(znor,
									['', zo, '', wrk.fnum, wrk.flin, zi])
								+ x);
					if assopt.optequ.Checked
					then begin
						zo := format('%8d', [aadr]);
						assf.addlstz(format(znor,
									['', zo, '', wrk.fnum, wrk.flin,
									copy(zi, 1, 1)]));
					end;
					if assu.wrk.pasequ
					then begin
						if lab > ''
						then equ.Add(format('   %s = $%x; %s// %s',
								[lab, aadr, #9, assf.getnote(x)]));
					end;
				end;
				exit;
			end;
			if uppercase(opc) = 'ORG' //# variabel
			then begin
				wrk.attr := taorg;
				cycl := 0;
				lopc := 0;
//				if wrk.asec[wrk.isec] > wrk.hsec[wrk.isec]
//				then wrk.hsec[wrk.isec] := wrk.asec[wrk.isec];
				if o1 = ''
				then begin
					wrk.asec[wrk.isec] := wrk.hsec[wrk.isec];
				end
				else begin
					zadr := assf.str2num (o1);
					wrk.isec := wrk.osec;
					wrk.asec[wrk.isec] := zadr;
				end;
				za := format('%4.4x', [wrk.asec[wrk.isec] and $FFFF]);
				if wrk.pass = 2
				then begin
					assf.addlstz(format(znor ,
								[za, '', '', wrk.fnum, wrk.flin, zi])
								+ x);
				end;
				exit;
			end;
			if uppercase(opc) = 'END' //# variabel
			then begin
				wrk.attr := taend;
				cycl := 0;
				lopc := 0;
				za := format('%4.4x', [wrk.asec[wrk.isec] and $FFFF]);
				if wrk.pass = 2
				then assf.addlstz(format(znor,
							[za, '', '', wrk.fnum, wrk.flin, zi])
							+ x);
				exit;
			end;
			if uppercase(opc) = 'DB' //# variabel
			then begin
				wrk.attr := tadb;
				cycl := 0;
				j := 0;
				for i := 3 to 99
				do begin
					o1 := assf.getstring (w, i);
					if o1 = ''
					then break;
					if o1[1] = ''''
					then begin
						for k := 2 to length(o1) - 1
						do begin
							hopc[j] := ord(o1[k]);
							inc(j);
						end;
					end
					else begin
						hopc[j] := assf.str2num(o1);
						inc(j);
					end;
				end;
				lopc := j;
				if (length(lab) > 0)
				and (wrk.pass = 1)
				then begin
					assf.putname(lab, atadr, lopc, wrk.asec[wrk.isec]);
				end;
				wrk.tabi := wrk.asec[wrk.isec];
				if wrk.tabl > wrk.tabi
				then wrk.tabl := wrk.tabi;
				za := format('%4.4x', [wrk.asec[wrk.isec] and $FFFF]);
				if cycl > 0
				then zc := '[' + inttostr(cycl) + ']'
				else zc := '';
				zi := '';
				if wrk.incl > 0
				then zi := inttostr(wrk.incl);
				j := 0;
				l := lopc;
				while l > 4
				do begin
					zo := format('%2.2x',[hopc[j]]);
					setht(hopc[j]);
					inc(j);
					dec(l);
					for k := 2 to 4
					do begin
						zo := zo + format('%2.2x', [hopc[j]]);
						setht(hopc[j]);
						inc(j);
						dec(l);
					end;
					if (wrk.pass = 2)
					and (assopt.optfdf.Checked or (x > ''))
					then assf.addlstz(format(znor ,
									[za, zo, zc, wrk.fnum, wrk.flin, zi])
									+ x);
					za := '';
					x := '';
				end;
				zo := '';
				while l > 0
				do begin
					zo := zo + format('%2.2x' , [hopc[j]]);
					setht(hopc[j]);
					inc(j);
					dec(l);
				end;
				if wrk.tabh < wrk.tabi
				then wrk.tabh := wrk.tabi;
				if (wrk.pass = 2)
				and (assopt.optfdf.Checked or (x > ''))
				then assf.addlstz(format(znor ,
								[za, zo, zc, wrk.fnum, wrk.flin, zi])
								+ x);
				inc(wrk.asec[wrk.isec], lopc);
				if wrk.asec[wrk.isec] > wrk.hsec[wrk.isec]
				then wrk.hsec[wrk.isec] := wrk.asec[wrk.isec];
				exit;
			end;
			if uppercase(opc) = 'DW' //# variabel
			then begin
				wrk.attr := tadb;
				cycl := 0;
				j := 0;
				for i := 3 to 99
				do begin
					o1 := assf.getstring (w, i);
					if o1 = ''
					then break;
					if o1[1] = ''''
					then begin
						for k := 2 to length(o1) - 1
						do begin
							zw := ord(o1[k]);
							hopc[j] := zw shr 8;
							inc(j);
							hopc[j] := zw and $FF;
							inc(j);
						end;
					end
					else begin
						zw := assf.str2num(o1);
						hopc[j] := zw shr 8;
						inc(j);
						hopc[j] := zw and $FF;
						inc(j);
					end;
				end;
				lopc := j;
				if (length(lab) > 0)
				and (wrk.pass = 1)
				then begin
					assf.putname(lab, atadr, lopc, wrk.asec[wrk.isec]);
				end;
				wrk.tabi := wrk.asec[wrk.isec];
				if wrk.tabl > wrk.tabi
				then wrk.tabl := wrk.tabi;
				za := format('%4.4x', [wrk.asec[wrk.isec] and $FFFF]);
				if cycl > 0
				then zc := '[' + inttostr(cycl) + ']'
				else zc := '';
				zi := '';
				if wrk.incl > 0
				then zi := inttostr(wrk.incl);
				j := 0;
				x := wrk.tall;
				l := lopc;
				while l > 4
				do begin
					zo := format('%2.2x',[hopc[j]]);
					setht(hopc[j]);
					inc(j);
					dec(l);
					for k := 2 to 4
					do begin
						zo := zo + format('%2.2x', [hopc[j]]);
						setht(hopc[j]);
						inc(j);
						dec(l);
					end;
					if (wrk.pass = 2)
					and (assopt.optfdf.Checked or (x > ''))
					then assf.addlstz(format(znor ,
									[za, zo, zc, wrk.fnum, wrk.flin, zi])
									+ x );
					za := '';
					x := '';
				end;
				zo := '';
				while l > 0
				do begin
					zo := zo + format('%2.2x' , [hopc[j]]);
					setht(hopc[j]);
					inc(j);
					dec(l);
				end;
				if wrk.tabh < wrk.tabi
				then wrk.tabh := wrk.tabi;
				if (wrk.pass = 2)
				and (assopt.optfdf.Checked or (x > ''))
				then assf.addlstz(format(znor ,
								[za, zo, zc, wrk.fnum, wrk.flin, zi])
								+ x );
				inc(wrk.asec[wrk.isec], lopc);
				if wrk.asec[wrk.isec] > wrk.hsec[wrk.isec]
				then wrk.hsec[wrk.isec] := wrk.asec[wrk.isec];
				exit;
			end;
			if uppercase(opc) = 'DS' //# variabel
			then begin
				wrk.attr := tads;
				cycl := 0;
				lopc := assf.str2num(o1);
				l := lopc;
				if (length(lab) > 0)
				and (wrk.pass = 1)
				then begin
					assf.putname(lab, atbyt, l, wrk.byta);
				end;
				zo := '';
				za := format('%4.4x', [wrk.byta and $FFFF]);
				inc(wrk.tabi, l);
				if wrk.tabh < wrk.tabi
				then wrk.tabh := wrk.tabi;
				if wrk.pass = 2
				then begin
					assf.addlstz(format(znor ,
								[za, zo, zc, wrk.fnum, wrk.flin, zi])
								+ x);
					if wrk.byta > 31
					then assf.putname('_STACK', atequ, 0, wrk.byta + lopc)
					else begin
						if wrk.bitn > 0
						then assf.putname('_STACK', atequ, 0,
									(wrk.bitn + 7) div 8 + 32 + lopc);
					end;
					if lab > ''
					then dbg.Add(format('%s=B%4.4x', [lab, wrk.byta]));
				end;
				inc(wrk.byta, lopc);
				exit;
			end;
			if uppercase(opc) = 'DBIT'
			then begin
				wrk.attr := tads;
				cycl := 0;
				lopc := assf.str2num(o1);
				l := lopc;
				if (length(lab) > 0)
				and (wrk.pass = 1)
				then begin
					assf.putname(lab, atbit, 0, wrk.bita);
				end;
				zo := format('%2.2x', [wrk.bita]);
				za := format('%2.2x.%d', [wrk.bita div 8 + 32, wrk.bita mod 8]);
				inc(wrk.tabi, l);
				if wrk.tabh < wrk.tabi
				then wrk.tabh := wrk.tabi;
				inc(wrk.bitn, 1);
				if wrk.pass = 2
				then begin
					assf.addlstz(format(znor ,
								[za, zo, zc, wrk.fnum, wrk.flin, zi])
								+ x);
					assf.putname('_BYTE', atequ, 0, wrk.bita div 8 + 32 + 1);
					if wrk.byta > 31
//					then assf.putname('_STACK', atequ, 0, (wrk.bitn + 7) div 8 + wrk.byta)
					then assf.putname('_STACK', atequ, 0,	wrk.byta)
					else assf.putname('_STACK', atequ, 0, (wrk.bitn + 7) div 8 + 32);
//					else assf.putname('_STACK', atequ, 0, (wrk.bitn + 7) div 8 + 32);
					if lab > ''
					then dbg.Add(format('%s=A%4.4x', [lab, wrk.bita]));
				end;
				inc(wrk.bita, lopc);
				exit;
			end;
//--
			inc(wrk.incl);
			zi := assf.getstring(wrk.toob, 2);
			inc(wrk.incn);
			if wrk.pass = 2
         then assf.addlstz(format(znor,
							[za,
							format(' inc#%3.3d', [wrk.incn]),
							zc, wrk.fnum, wrk.flin, ''])
							+ x );
			// source dir
			if not assf.ass_file(sdir + zi + '.mac', x, nil, false)
			and not assf.ass_file(sdir + zi + '.inc', x, nil, false)
			then begin
				// project dir
				if not assf.ass_file(pdir + zi + '.mac', x, nil, false)
				and not assf.ass_file(pdir + zi + '.inc', x, nil, false)
				then begin
					// include dir
					if not assf.ass_file(idir + zi + '.mac', x, nil, false)
					and not assf.ass_file(idir + zi + '.inc', x, nil, false)
					then begin
						// program dir
						if not assf.ass_file(edir + zi + '.mac', x, nil, false)
						and not assf.ass_file(edir + zi + '.inc', x, nil, false)
                  then begin
                  	result := false;
                  end;
					end;
				end;
			end;
         dec(wrk.incl);
//--
			if trim(opc) > ' '
			then wrk.attr := tamac
			else wrk.attr := tanor;
		end;
	end;
end;

end.
