unit disu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, simu;

{$i tracetab.pic}

type
	tstab =
	record
		adr:			word;
		lst:			string[40];
	end;

	Tdisf =
	class(TForm)
		lbadr: 		TListBox;
		lbram: 		TListBox;
		lbbit: 		TListBox;
		lbsfr: 		TListBox;
		Label1: 		TLabel;
		Label2: 		TLabel;
		Label3: 		TLabel;
		Label4: 		TLabel;
		mm1: 			TMainMenu;
		Disass1: 	TMenuItem;
		lschen1: 	TMenuItem;
		procedure 	lschen1Click(Sender: TObject);
	private		{ Private-Deklarationen }
		procedure 	stabadd(adr: word; src: string);
	public		{ Public-Deklarationen }
//		procedure 	Clear;
		procedure	Rini;
		procedure	Wini;
	end;

var
	disf:		Tdisf;
	atab:		array [0..1023] of word;
	vtab:		array [0..1023] of boolean;
	aein,
	aaus:		integer;
	stab:		array [0..1023] of tstab;
	sein:		integer;
	opc:			byte;
	rel:			shortint;
	o:				ptdat;

implementation

uses assu;

{$R *.DFM}

procedure Tdisf.RIni;
begin
	assf.RIniForm(Name, Self);
//	assf.RIniMenu(Name, Port1);
end;

procedure Tdisf.WIni;
begin
	assf.WIniForm(Name, Self);
//	assf.WIniMenu(Name, Port1);
end;

procedure Tdisf.lschen1Click(Sender: TObject);
var
	i:			integer;
begin
	aein := 0;
	aaus := 0;
	sein := 0;
	for i := low(vtab) to high(vtab)
	do vtab[i] := false;
end;

procedure Tdisf.stabadd(adr: word; src: string);
begin
	if sein > high(stab)
	then exit;
	stab[sein].adr := adr;
	stab[sein].lst := src;
	inc(sein);
end;

function opv(): byte;
begin
	result := wrk.prog[wrk.padr];
	inc(wrk.padr);
end;

procedure code00(adr: word); //NOP		amnn, amnn
begin
	disf.stabadd(adr, optab[0]);
end;

procedure code01(adr: word); //AJMP	amnn, amnn
var
	a:			word;
begin
	a := wrk.padr and $F800 + (opc shr 5) * 256 + opv();
	disf.stabadd(wrk.padr, optab[1]);
end;

procedure code02(adr: word); //LJMP	amnn, amnn
var
	a:			word;
begin
	a := opv() * 256 + opv();
	disf.stabadd(wrk.padr, optab[2]);
	wrk.padr := a;
end;

procedure code03(adr: word); //RR 		amac, amnn
begin
	disf.stabadd(wrk.padr, optab[3]);
end;

procedure code04(adr: word); //INC   	amac, amnn
begin
	disf.stabadd(wrk.padr, optab[4]);
end;

procedure code05(adr: word); //INC   	amda, amnn
begin
	o := @p.o1;
	pamda;
	inc(p.o1.wrt);
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code06(adr: word); //INC		amir, amnn
begin
	o := @p.o1;
	pamir;
	inc(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code08; //INC		amdr, amnn
begin
	o := @p.o1;
	pamdr;
	inc(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code10; //JBC   	ambt, amnn
begin
	o := @p.o1;
	pambt;
	rel := opv();
	p.o2.jmp := false;
	if p.o1.wrt > 0
	then begin
		wrk.padr := wrk.padr + rel;
		bitm(p.o1.adr, false);
		p.o1.wrt := 0;
		p.o2.jmp := true;
	end;
	ac := wrk.sfrs[_A];
end;

procedure code11; //ACALL	amsp, amnn
var
	a:			word;
begin
	a := wrk.padr and $F800 + (opc shr 5) * 256 + opv();
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr);
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr shr 8);
	wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
	wrk.padr := a;
	p.o1.wrt := wrk.sfrs[_SP];
	p.o2.jmp := true;
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code12; //LCALL	amsp, amnn
var
	a:			word;
begin
	a := opv() * 256 + opv();
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr);
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr shr 8);
	wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
	wrk.padr := a;
	p.o1.wrt := wrk.sfrs[_SP];
	p.o2.jmp := true;
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code13; //RRC		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	if bitg(_CY)
	then ac := ac or $100;
	bitm(_CY, (ac and 1) > 0);
	ac := ac shr 1;
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure code14;	//DEC   	amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	dec(ac);
	p.o1.wrt := ac;
end;

procedure code15; //DEC   	amda, amnn
begin
	o := @p.o1;
	pamda;
	dec(p.o1.wrt);
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code16; //DEC   	amir, amnn
begin
	o := @p.o1;
	pamir;
	dec(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code18; //DEC   	amdr, amnn
begin
	o := @p.o1;
	pamdr;
	dec(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code20; //JB		ambt, amnn
begin
	o := @p.o1;
	pambt;
	rel := opv();
	if p.o1.wrt > 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code22; //RET		amsp, amnn
begin
	wrk.padr := wrk.iram[wrk.sfrs[_SP]] shl 8;
	dec(wrk.sfrs[_SP]);
	wrk.padr := wrk.padr or wrk.iram[wrk.sfrs[_SP]];
	dec(wrk.sfrs[_SP]);
	p.o1.wrt := wrk.sfrs[_SP];
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code23; //RL		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := ac shl 1 + ac shr 7;
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure code24; //ADD		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code25; //ADD		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code26; //ADDC		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code28;	//ADD		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code30;	//JNB   	ambt, amnn
begin
	o := @p.o1;
	pambt;
	rel := opv();
	p.o2.jmp := false;
	if p.o1.wrt = 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code32; //RETI	amsp, amnn
begin
	wrk.padr := wrk.iram[wrk.sfrs[_SP]] shl 8;
	dec(wrk.sfrs[_SP]);
	wrk.padr := wrk.padr or wrk.iram[wrk.sfrs[_SP]];
	dec(wrk.sfrs[_SP]);
	p.o1.wrt := wrk.sfrs[_SP];
	wrk.ints := true;
	wrk.intu[wrk.intl] := false;
	while not wrk.intu[wrk.intl] and (wrk.intl > 0)
	do dec(wrk.intl);
	pint.intl := 7;
	ptwrt;
	pint.intl := 0;
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code33; //RLC		amac, amnn
var
	flcy:		boolean;
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := ac shl 1;
	if bitg(_CY)
	then ac := ac or $01;
	flcy := (ac and $100) > 0;
	bitm(_CY, flcy);
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure code34;	//ADDC	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code35;	//ADDC	amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code36;	//ADDC	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code38;	//ADDC	amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code40; //JC		amcc, amnn
begin
	rel := opv();
	p.o2.jmp := false;
	if bitg(_CY)
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code42;	//ORL  	amda, amac
begin
	o := @p.o1;
	pamda;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) or ac;
	simf.sdad(p.o1.adr, p.o1.wrt);
	p.o2.wrt := ac;
end;

procedure code43;	//ORL		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) or p.o2.wrt;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code44;	//ORL   	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code45;	//ORL		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code46; //ORL		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code48;	//ORL		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code50; //JNC		amcc, amnn
begin
	rel := opv();
	p.o2.jmp := false;
	if not bitg(_CY)
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code52;	//ANL		amda, amac
begin
	o := @p.o1;
	pamda;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) and ac;
	p.o2.wrt := ac;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code53;	//ANL		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) and p.o2.wrt;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code54;	//ANL		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code55;	//ANL		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code56;	//ANL		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code58;	//ANL		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code60; //JZ		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	rel := opv();
	p.o2.jmp := false;
	if ac = 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
	p.o1.wrt := ac;
end;

procedure code62; //XRL		amda, amac
begin
	o := @p.o1;
	pamda;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) xor ac;
	simf.sdad(p.o1.adr, p.o1.wrt);
	p.o2.wrt := ac;
end;

procedure code63;	//XRL		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) xor p.o2.wrt;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code64; //XRL		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code65; //XRL		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code66; //XRL		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code68; //XRL		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code70; //JNZ		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	rel := opv();
	p.o2.jmp := false;
	if ac > 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
	p.o1.wrt := ac;
end;

procedure code72; //ORL		amcc, ambt
begin
	o := @p.o2;
	pambt;
	if p.o2.wrt > 0
	then bitm(_CY, true);
end;

procedure code73; //JMP		amad, amnn (@a+DPTR)
begin
	o := @p.o1;
	pamad;
	wrk.padr := p.o1.wadr;
	p.o2.jmp := true;
end;

procedure code74; //MOV		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code75; //MOV		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := p.o2.wrt;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code76; //MOV		amir, ami1
begin
	o := @p.o1;
	pamir;
	o := @p.o2;
	pami1;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code78; //MOV		amdr, ami1
begin
	o := @p.o1;
	pamdr;
	o := @p.o2;
	pami1;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code80;	//SJMP 	amnn, amnn
begin
	rel := opv();
	wrk.padr := wrk.padr + rel;
	p.o2.jmp := true;
end;

procedure code82; //ANL		amcc, ambt
begin
	o := @p.o2;
	pambt;
	bitm(_CY, ((p.o2.adr > 0) and bitg(_CY)));
end;

procedure code83; //MOVC	amac, amap
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamap;
	ac := wrk.prog[p.o2.wadr];
	p.o1.wrt := ac;
end;

procedure code84; //DIV		amac, amrb
var
	flcy,
	flov:		boolean;
	z1,
	z2:		byte;
begin
	o := @p.o1;
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamrb;
	flcy := false;
	flov := false;
	if p.o2.wrt = 0
	then flov := true
	else begin
		z1 := ac div wrk.sfrs[_B];
		z2 := z1 * wrk.sfrs[_B];
		wrk.sfrs[_a] := z1;
		wrk.sfrs[_B] := (ac - z2);
		ac := wrk.sfrs[_a];
		p.o2.wrt := wrk.sfrs[_B];
	end;
	bitm(_CY, flcy);
	bitm(_OV, flov);
	p.o1.wrt := ac;
end;

procedure code85; //MOV		amda, amda
begin
	o := @p.o2;
	pamda;
	o := @p.o1;
	pamda;
	p.o1.wrt := p.o2.wrt;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code86; //MOV		amda, amir
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pamir;
	p.o1.wrt := p.o2.wrt;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code88; //MOV		amda, amdr
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pamdr;
	p.o1.wrt := p.o2.wrt;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure code90; //MOV		amdd, ami2
begin
	o := @p.o2;
	pami2;
	p.o1.wadr := p.o2.wadr;
	wrk.sfrs[_DPH] := p.o1.wadr div 256;
	wrk.sfrs[_DPL] := p.o2.adr;
end;

procedure code92; //MOV 	ambt, amcc
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := byte(bitg(_CY));
	bitm(p.o1.adr, (p.o1.wrt > 0));
	ac := wrk.sfrs[_A];
end;

procedure code93;	//MOVC	amac, amad
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamad;
	ac := wrk.prog[p.o2.wadr];
	p.o1.wrt := ac;
end;

procedure code94;	//SUBB	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code95;	//SUBB	amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code96; //SUBB	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code98; //SUBB	amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure codeA0; //ORL		amcc, amnb
begin
	o := @p.o2;
	pamnb;
	p.o1.wrt := p.o2.wrt or byte(bitg(_CY));
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeA2; //MOV		amcc, ambt
begin
	o := @p.o2;
	pambt;
	p.o1.wrt := p.o2.wrt;
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeA3; //INC   DPTR
begin
	o := @p.o1;
	pamdd;
	inc(p.o1.wadr);
	wrk.sfrs[_DPH] := p.o1.wadr div 256;
	wrk.sfrs[_DPL] := p.o1.wadr;
end;

procedure codeA4; //MUL		amac, amrb
var
	flcy,
	flov:		boolean;
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamrb;
	flcy := false;
	ac := ac * p.o2.wrt;
	flov := ac > 256;
	wrk.sfrs[_B] := ac div 256;
	p.o2.wrt := ac div 256;
	ac := ac and $FF;
	bitm(_CY, flcy);
	bitm(_OV, flov);
	p.o1.wrt := ac;
end;

var
	ca5:	byte = $ff;
	rb5:  byte = 0;

procedure codeA5; // fr test setzen der cpu,
						// sonst nicht benutzt;
var
	i:			integer;
begin
//
	o := @p.o1;
	ca5 := ca5 xor $FF;
	rb5 := (rb5 + $008) mod 32;
	for i := 0 to 63
	do if i and 1 > 0
		then wrk.iram[i] := i xor $FF
		else wrk.iram[i] := i;
	bitm(_CY, (ca5 > 0));
	wrk.sfrs[_SP] := $5f;
	wrk.sfrs[_A] := $83;
	ac := $83;
	wrk.sfrs[_B] := $08;
	wrk.sfrs[_DPH] := opv;
	wrk.sfrs[_DPL] := opv;
	wrk.sfrs[_PSW] := rb5;
{$ifdef debug}
	o.vadr := wrk.sfrs[_DPH] * 256 + wrk.sfrs[_DPL];
	o.vwrt := wrk.sfrs[_SP];
{$endif}
	if wrk.sfrs[_DPH] + wrk.sfrs[_DPL] > 0
	then begin
		inc(wrk.sfrs[_SP]);
		wrk.iram[wrk.sfrs[_SP]] := wrk.sfrs[_DPL];
		inc(wrk.sfrs[_SP]);
		wrk.iram[wrk.sfrs[_SP]] := wrk.sfrs[_DPH];
{$ifdef debug}
		o.vwrt := wrk.sfrs[_SP];
{$endif}
	end;
//
end;

procedure codeA6; //MOV		amir, amda
begin
	o := @p.o1;
	pamir;
	o := @p.o2;
	pamda;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure codeA8; //MOV		amdr, amda
begin
	o := @p.o1;
	pamdr;
	o := @p.o2;
	pamda;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure codeB0; //ANL		amcc, amnb
begin
	o := @p.o2;
	pamnb;
	p.o1.wrt := p.o2.wrt and byte(bitg(_CY));
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeB2; //CPL		ambt, amnn
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := byte(not bitg(p.o1.adr));
	bitm(p.o1.adr, (p.o1.wrt > 0));
	ac := wrk.sfrs[_A];
end;

procedure codeB3; //CPL		amcc, amnn
begin
	p.o1.wrt := byte(not bitg(_CY));
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeB4; //CJNE	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	rel := opv();
	if ac <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, ac < p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure codeB5; //CJNE	amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	rel := opv();
	if ac <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, ac < p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure codeB6; //CJNE	amir, ami1
begin
	o := @p.o1;
	pamir;
	o := @p.o2;
	pami1;
	rel := opv();
	if p.o1.wrt <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, p.o1.wrt < p.o2.adr);
end;

procedure codeB8; //CJNE	amdr, ami1
begin
	o := @p.o1;
	pamdr;
	o := @p.o2;
	pami1;
	rel := opv();
	if p.o1.wrt <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, p.o1.wrt < p.o2.adr);
end;

procedure codeC0; //PUSH	amda, amsp
begin
	o := @p.o1;
	pamda;
{$ifdef debug}
	p.o2.vwrt := wrk.sfrs[_SP];
{$endif}
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], p.o1.wrt);
	wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
	p.o2.wrt := wrk.sfrs[_SP];
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure codeC2; //CLR		ambt, amnn
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := 0;
	bitm(p.o1.adr, false);
	ac := wrk.sfrs[_A];
end;

procedure codeC3; //CLR		amcc, amnn
begin
	bitm(_CY, false);
	p.o1.wrt := byte(bitg(_CY));
end;

procedure codeC4; //SWAP	amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := (ac shr 4 or ac shl 4) and $FF;
	p.o1.wrt := ac;
end;

procedure codeC5; //XCH		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	wrk.sfrs[_a] := p.o2.wrt;
	simf.sdad(p.o2.adr, ac);
	p.o2.wrt := ac;
	ac := wrk.sfrs[_a];
	p.o1.wrt := ac;
end;

procedure codeC6; //XCH		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	wrk.sfrs[_a] := p.o2.wrt;
	sram(p.o2.adr, ac);
	p.o2.wrt := ac;
	ac := wrk.sfrs[_a];
	p.o1.wrt := ac;
end;

procedure codeC8; //XCH		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	wrk.sfrs[_a] := p.o2.wrt;
	sram(p.o2.adr, ac);
	p.o2.wrt := ac;
	ac := wrk.sfrs[_a];
	p.o1.wrt := ac;
end;

procedure codeD0; //POP		amda, amsp
begin
	o := @p.o1;
	pamda;
{$ifdef debug}
	p.o2.vwrt := wrk.sfrs[_SP];
{$endif}
	simf.sdad(p.o1.adr, wrk.iram[wrk.sfrs[_SP]]);
	p.o1.wrt := wrk.iram[wrk.sfrs[_SP]];
	dec(wrk.sfrs[_SP]);
	p.o2.wrt := wrk.sfrs[_SP];
	ac := wrk.sfrs[_A];
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure codeD2; //SETB	ambt, amnn
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := 1;
	bitm(p.o1.adr, true);
	ac := wrk.sfrs[_A];
end;

procedure codeD3; //SETB	amcc, amnn
begin
	p.o1.wrt := 1;
	bitm(_CY, true);
end;

procedure codeD4; //Da		amac, amnn
var
	flcy:		boolean;
begin
{$ifdef debug}
	pamac;
{$endif}
	if bitg(_aC)
	or (ac and $0f > 9)
	then inc(ac, 6);
	flcy := ac > 256;
	if flcy
	or (ac and $f0 > $90)
	then inc(ac, $60);
	flcy := ac > 256;
	wrk.sfrs[_a] := ac;
	bitm(_CY, flcy);
	p.o1.wrt := ac;
end;

procedure codeD5; //DJNZ	amda, amnn
begin
	o := @p.o1;
	pamda;
	rel := opv();
	dec(p.o1.wrt);
	simf.sdad(p.o1.adr, p.o1.wrt);
	if p.o1.wrt <> 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
	ac := p.o1.wrt;
end;

procedure codeD6; //XCHD	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	sram(p.o2.adr, p.o2.wrt and $F0 + ac and $0F);
	ac := p.o2.wrt and $0f + ac and $F0;
	p.o2.wrt := wrk.iram[p.o2.adr];
	p.o1.wrt := ac;
end;

procedure codeD8; //DJNZ	amdr, amnn
begin
	o := @p.o1;
	pamdr;
	rel := opv();
	p.o2.jmp := false;
	dec(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
	if p.o1.wrt <> 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure codeE0; //MOVX	amac, amid
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamid;
	ac :=	eram[p.o2.wadr];
	p.o1.wrt := ac;
end;

procedure codeE2; //MOVX	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := wrk.iram[p.o2.adr];
	p.o1.wrt := ac;
end;

procedure codeE4; //CLR		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o1;
	ac := 0;
	p.o1.wrt := ac;
end;

procedure codeE5; //MOV		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := p.o2.wrt;
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure codeE6; //MOV		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure codeE8; //MOV		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure codeF0; //MOVX	amid, amac
begin
	o := @p.o1;
	pamid;
	eram[p.o1.wadr] := ac;
	p.o2.wrt := ac;
end;

procedure codeF2; //MOVX	amir, amac
begin
	o := @p.o1;
	pamir;
	eram[p.o1.adr] := ac;
	p.o2.wrt := ac;
end;

procedure codeF4; //CPL		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := ac xor $FF;
	p.o1.wrt := ac;
end;

procedure codeF5; //MOV		amda, amac
begin
	o := @p.o1;
	pamda;
	p.o2.wrt := ac;
	p.o1.wrt := ac;
	simf.sdad(p.o1.adr, p.o1.wrt);
end;

procedure codeF6; //MOV		amir, amac
begin
	o := @p.o1;
	pamir;
	p.o2.wrt := ac;
	p.o1.wrt := ac;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure codeF8; //MOV   amdr, amac
begin
	o := @p.o1;
	pamdr;
	p.o2.wrt := ac;
	p.o1.wrt := ac;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure addtrc(kenn, bit: byte);
begin
	p := @trat[trai];
	p.o1.adr := bit;
	p.o1.wrt := 1;
	p.o1.reg := kenn;
	p.o1.op := $A5;
	if wrk.ptrc
	then begin
		if assopt.opttrc.Checked
		then write(ftrc, trat[trai]);
		trai := (trai + 1) mod (high(trat) + 1);
	end;
end;

//---------------------------------------
// bearbeiten
procedure code();
begin
	if (wrk.brtr[wrk.padr] and 4 > 0)
	and wrk.ptrc
	then begin
		wrk.ptrc := false;
		addtrc($12, 0);
	end;
	if wrk.brtr[wrk.padr] and 2 > 0
	then begin
		wrk.ptrc := true;
//		jmpadr := adra(wrk.padr) + ' ';
	end;
	p := @trat[trai];
	p.clck := comz;
	p.o1.pcnt := wrk.padr;
	opc := wrk.prog[wrk.padr];
	inc(wrk.padr);
	p.o1.op := opc;
	inc(comz, wrk.clkt[opc]);

{$ifdef debug}
	p.o1.vwrt := ac;
{$endif}

	// quelladresse und wert
	case opc of
	$00: code00;    // NOP
	$01: code01;    // AJMP
	$02: code02;    // LJMP
	$03: code03;    // RR
	$04: code04;    // INC
	$05: code05;    // INC
	$06: code06;    // INC
	$07: code06;    // INC
	$08: code08;    // INC
	$09: code08;    // INC
	$0A: code08;    // INC
	$0B: code08;    // INC
	$0C: code08;    // INC
	$0D: code08;    // INC
	$0E: code08;    // INC
	$0F: code08;    // INC
	$10: code10;    // JBC
   $11: code11;    // ACALL
   $12: code12;    // LCALL
   $13: code13;    // RRC
   $14: code14;    // DEC
   $15: code15;    // DEC
   $16: code16;    // DEC
   $17: code16;    // DEC
	$18: code18;    // DEC
   $19: code18;    // DEC
   $1A: code18;    // DEC
	$1B: code18;    // DEC
	$1C: code18;    // DEC
   $1D: code18;    // DEC
	$1E: code18;    // DEC
   $1F: code18;    // DEC
	$20: code20;    // JB
	$21: code01;    // AJMP
   $22: code22;    // RET
   $23: code23;    // RL
   $24: code24;    // ADD
   $25: code25;    // ADD
   $26: code26;    // ADD
   $27: code26;    // ADD
   $28: code28;    // ADD
   $29: code28;    // ADD
   $2A: code28;    // ADD
	$2B: code28;    // ADD
   $2C: code28;    // ADD
   $2D: code28;    // ADD
	$2E: code28;    // ADD
   $2F: code28;    // ADD
   $30: code30;    // JNB
	$31: code11;    // ACALL
   $32: code32;    // RETI
   $33: code33;    // RLC
	$34: code34;    // ADDC
   $35: code35;    // ADDC
	$36: code36;    // ADDC
	$37: code36;    // ADDC
	$38: code38;    // ADDC
   $39: code38;    // ADDC
   $3A: code38;    // ADDC
   $3B: code38;    // ADDC
   $3C: code38;    // ADDC
   $3D: code38;    // ADDC
   $3E: code38;    // ADDC
   $3F: code38;    // ADDC
   $40: code40;    // JC
   $41: code01;    // AJMP
   $42: code42;    // ORL
   $43: code43;    // ORL
	$44: code44;    // ORL
   $45: code45;    // ORL
   $46: code46;    // ORL
	$47: code46;    // ORL
   $48: code48;    // ORL
	$49: code48;    // ORL
	$4A: code48;    // ORL
   $4B: code48;    // ORL
	$4C: code48;    // ORL
   $4D: code48;    // ORL
	$4E: code48;    // ORL
	$4F: code48;    // ORL
   $50: code50;    // JNC
   $51: code11;    // ACALL
   $52: code52;    // ANL
   $53: code53;    // ANL
   $54: code54;    // ANL
   $55: code55;    // ANL
   $56: code56;    // ANL
   $57: code56;    // ANL
   $58: code58;    // ANL
   $59: code58;    // ANL
	$5A: code58;    // ANL
   $5B: code58;    // ANL
   $5C: code58;    // ANL
	$5D: code58;    // ANL
   $5E: code58;    // ANL
   $5F: code58;    // ANL
	$60: code60;    // JZ
   $61: code01;    // AJMP
	$62: code62;    // XRL
   $63: code63;    // XRL
	$64: code64;    // XRL
	$65: code65;    // XRL
	$66: code66;    // XRL
	$67: code66;    // XRL
   $68: code68;    // XRL
   $69: code68;    // XRL
   $6A: code68;    // XRL
   $6B: code68;    // XRL
   $6C: code68;    // XRL
   $6D: code68;    // XRL
   $6E: code68;    // XRL
   $6F: code68;    // XRL
	$70: code70;    // JNZ
   $71: code11;    // ACALL
   $72: code72;    // ORL
	$73: code73;    // JMP
   $74: code74;    // MOV
   $75: code75;    // MOV
	$76: code76;    // MOV
   $77: code76;    // MOV
	$78: code78;    // MOV
   $79: code78;    // MOV
   $7A: code78;    // MOV
   $7B: code78;    // MOV
	$7C: code78;    // MOV
	$7D: code78;    // MOV
   $7E: code78;    // MOV
   $7F: code78;    // MOV
   $80: code80;    // SJMP
   $81: code01;    // AJMP
   $82: code82;    // ANL
   $83: code83;    // MOVC
   $84: code84;    // DIV
	$85: code85;    // MOV
	$86: code86;    // MOV
   $87: code86;    // MOV
   $88: code88;    // MOV
	$89: code88;    // MOV
   $8A: code88;    // MOV
   $8B: code88;    // MOV
	$8C: code88;    // MOV
   $8D: code88;    // MOV
	$8E: code88;    // MOV
   $8F: code88;    // MOV
   $90: code90;    // MOV
   $91: code11;    // ACALL
   $92: code92;    // MOV
	$93: code93;    // MOVC
	$94: code94;    // SUBB
   $95: code95;    // SUBB
   $96: code96;    // SUBB
   $97: code96;    // SUBB
   $98: code98;    // SUBB
   $99: code98;    // SUBB
   $9A: code98;    // SUBB
   $9B: code98;    // SUBB
	$9C: code98;    // SUBB
   $9D: code98;    // SUBB
   $9E: code98;    // SUBB
	$9F: code98;    // SUBB
   $A0: codeA0;    // ORL
   $A1: code01;    // AJMP
	$A2: codeA2;    // MOV
	$A3: codeA3;    // INC
	$A4: codeA4;    // MUL
   $A5: codeA5;    // EXTOPC
   $A6: codeA6;    // MOV
   $A7: codeA6;    // MOV
   $A8: codeA8;    // MOV
   $A9: codeA8;    // MOV
	$AA: codeA8;    // MOV
	$AB: codeA8;    // MOV
	$AC: codeA8;    // MOV
   $AD: codeA8;    // MOV
   $AE: codeA8;    // MOV
   $AF: codeA8;    // MOV
   $B0: codeB0;    // ANL
   $B1: code11;    // ACALL
	$B2: codeB2;    // CPL
   $B3: codeB3;    // CPL
   $B4: codeB4;    // CJNE
	$B5: codeB5;    // CJNE
   $B6: codeB6;    // CJNE
   $B7: codeB6;    // CJNE
	$B8: codeB8;    // CJNE
   $B9: codeB8;    // CJNE
	$BA: codeB8;    // CJNE
   $BB: codeB8;    // CJNE
   $BC: codeB8;    // CJNE
   $BD: codeB8;    // CJNE
   $BE: codeB8;    // CJNE
   $BF: codeB8;    // CJNE
   $C0: codeC0;    // PUSH
	$C1: code01;    // AJMP
	$C2: codeC2;    // CLR
   $C3: codeC3;    // CLR
	$C4: codeC4;    // SWAP
   $C5: codeC5;    // XCH
   $C6: codeC6;    // XCH
   $C7: codeC6;    // XCH
	$C8: codeC8;    // XCH
   $C9: codeC8;    // XCH
   $CA: codeC8;    // XCH
	$CB: codeC8;    // XCH
   $CC: codeC8;    // XCH
   $CD: codeC8;    // XCH
	$CE: codeC8;    // XCH
   $CF: codeC8;    // XCH
	$D0: codeD0;    // POP
   $D1: code11;    // ACALL
   $D2: codeD2;    // SETB
   $D3: codeD3;    // SETB
   $D4: codeD4;    // DA
   $D5: codeD5;    // DJNZ
   $D6: codeD6;    // XCHD
   $D7: codeD6;    // XCHD
	$D8: codeD8;    // DJNZ
	$D9: codeD8;    // DJNZ
   $DA: codeD8;    // DJNZ
   $DB: codeD8;    // DJNZ
	$DC: codeD8;    // DJNZ
   $DD: codeD8;    // DJNZ
	$DE: codeD8;    // DJNZ
	$DF: codeD8;    // DJNZ
   $E0: codeE0;    // MOVX
	$E1: code01;    // AJMP
   $E2: codeE2;    // MOVX
   $E3: codeE2;    // MOVX
	$E4: codeE4;    // CLR
   $E5: codeE5;    // MOV
	$E6: codeE6;    // MOV
   $E7: codeE6;    // MOV
   $E8: codeE8;    // MOV
   $E9: codeE8;    // MOV
   $EA: codeE8;    // MOV
   $EB: codeE8;    // MOV
   $EC: codeE8;    // MOV
   $ED: codeE8;    // MOV
   $EE: codeE8;    // MOV
	$EF: codeE8;    // MOV
	$F0: codeF0;    // MOVX
   $F1: code11;    // ACALL
   $F2: codeF2;    // MOVX
   $F3: codeF2;    // MOVX
	$F4: codeF4;    // CPL
   $F5: codeF5;    // MOV
   $F6: codeF6;    // MOV
	$F7: codeF6;    // MOV
   $F8: codeF8;    // MOV
   $F9: codeF8;    // MOV
	$FA: codeF8;    // MOV
   $FB: codeF8;    // MOV
	$FC: codeF8;    // MOV
	$FD: codeF8;    // MOV
   $FE: codeF8;    // MOV
   $FF: codeF8;    // MOV
	end;
	ac := ac and $FF;
	wrk.sfrs[_A] := ac;
	p.o2.pcnt := wrk.padr;
	if wrk.ptrc
	then begin
		if assopt.opttrc.Checked
		then write(ftrc, trat[trai]);
		trai := (trai + 1) mod (high(trat) + 1);
	end;

	tim.tick(wrk.clkt[opc]);
	if (tim.Tag > 0)
	and wrk.ptrc
	then begin
//		addtrc($11, tim.tag);
		tim.tag := 0;
	end;
	if bitg(_EA)
	then begin
		wrk.tint;
		if wrk.ibit > 0
		then begin
			pint.intl := wrk.intl * 8 + wrk.intf[wrk.intl];
			ptwrt;
			pint.intl := 0;
			if wrk.ptrc
			then addtrc($11, wrk.ibit);
			wrk.ibit := 0;
		end;
	end;
	if wrk.brtr[wrk.padr] and 1 > 0
	then begin
		wrk.pbrk := true;
//		if wrk.ptrc
//		then begin
//			if assopt.opttrc.Checked
//			then write(ftrc, trat[trai]);
//			trai := (trai + 1) mod (high(trat) + 1);
//		end;
	end;
	p.o2.op := wrk.sfrs[_PSW];

	application.ProcessMessages;
end;

procedure anzt(ind: integer);
const
	fl = '%10d %4.4x %s %-12s %-7s %s';
	fv = '                                          %s';
	fe = '> %s';
var
	km,
	vm:		string[2];
	ad,
	sp:		string[15];
	ezei,
	tzei:	  	string[255];
{$ifdef debug}
	vzei:		string[255];
	sv:		string[15];
{$endif}
	i:			integer;
begin
	if simf.tlb.Items.count > 256
	then simf.tlb.Items.Delete(0);
	tzei := '';
	ezei := '';
{$ifdef debug}
	vzei := '';
	sv := '';
{$endif}
	km := '';
	vm := '';
	sp := '';
	for i := 0 to 2
	do begin
		if i = 0
		then o := @trat[ind].o1
		else o := @trat[ind].o2;
		case amt[trat[ind].o1.op, i] of
		amnn:					// none
			break;
		amac:					// acc
			begin
				tzei := tzei + km
								 + 'A'
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ 'A'
										+ ht[o.vwrt];
{$endif}
			end;
		amap:					// acc + pc
			begin
				tzei := tzei + km
								 + format('a+PC>0%4.4xh', [o.wadr])
								 + ht[o.wrt];
			end;
		amad:					// acc + dp
			begin
				tzei := tzei + km
								 + format('a+DP=0%4.4xh', [o.wadr]);
			end;
		ambt:					// bit adr
			begin
				tzei := tzei + km
								 + tbit[o.adr]
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ tbit[o.adr]
										+ ht[o.vwrt];
{$endif}
			end;
		amcc:					// C
			tzei := tzei + km
							 + 'C';
		amda:					// iram / sfr adr
			begin
				if o.adr > 127
				then tzei := tzei + km
								 + tsfr[o.adr]
								 + ht[o.wrt]
				else tzei := tzei + km
								 + tram[o.adr]
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then if o.adr > 127
						then vzei := vzei + km
												+ tsfr[o.adr]
												+ ht[o.vwrt]
						else vzei := vzei + km
												+ tram[o.adr]
												+ ht[o.vwrt];
{$endif}
			end;
		amdd:					// dir dp
			begin
				tzei := tzei + km
								 + format('DP=0%4.4xh', [o.wadr]);
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ format('DP=0%4.4xh', [o.vadr]);
{$endif}
			end;
		amdr:					// reg
			begin
				tzei := tzei + km
								 + format('R%2.2x', [o.reg])
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ format('R%2.2x', [o.reg])
										+ ht[o.vwrt];
{$endif}
			end;
		ameo:					// extopc bei test
			begin
				case o.reg of
{$ifdef debug}
				$10:	ezei := format('DP:0%4.4xh SP',
												[o.vadr])
								 + ht[o.vwrt];
{$endif}
				$11:	ezei := '           ' + tbit[o.adr]
								 + ht[o.wrt];
				$12:
					begin
						ezei := '--- #trace off';
						jmpadr := '';
					end;
				$13:	ezei := '       set ' + tbit[o.adr]
								 + ht[o.wrt];
				end;
			end;
		ami1:					// imm 8
			tzei := tzei + km
							 + '#'
							 + ht[o.wrt];
		ami2:					// imm 16 bit
			tzei := tzei + km
							 + format('#=0%4.4xh', [o.wadr]);
		amid:					// indir dp
			tzei := tzei + km
							 + format('DP>0%4.4xh', [o.wadr]);
		amir:					// indir reg
			begin
				tzei := tzei + km
								 + format('R%2.2x>%s', [o.reg, tram[o.adr]])
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ format('R%2.2x>0%2.2xh', [o.reg, o.adr])
										+ ht[o.vwrt];
{$endif}
			end;
		amjp:
			if trat[ind].o2.jmp
			then begin
				ad := adra(trat[ind].o2.pcnt) + ' ';
				tzei := tzei + km + ad;
			end
			else ad := '';
		amnb:					// not bit adr
			begin
				tzei := tzei + km
								 + '/'
								 + tbit[o.adr]
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ '/'
										+ tbit[o.adr]
										+ ht[o.vwrt];
{$endif}
			end;
		amrb:					// accu B
			begin
				tzei := tzei + km
								 + 'B'
								 + ht[o.wrt];
{$ifdef debug}
				vzei := vzei + km
								 + 'B'
								 + ht[o.vwrt];
{$endif}
			end;
		amsp:					// stackp
			begin
				sp := vm
					+ 'SP'
					+ ht[o.wrt];
{$ifdef debug}
				sv := sv + km
							+ 'SP'
							+ ht[o.vwrt];
{$endif}
			end;
		end;
		km := ',';
		vm := ' ';
	end;
{$ifdef debug}
	if vzei > ''
	then 	simf.tlb.items.add(format(fv, [
				ad + vzei + sv]));
{$endif}
	if ezei > ''
	then begin
		simf.tlb.items.add(format(fe, [
				ezei]));
		exit;
	end;
	if copy(adra(trat[ind].o1.pcnt), 2, 2) <> '..'
	then jmpadr := adra(trat[ind].o1.pcnt)
	else jmpadr := '';
	simf.tlb.items.add(format(fl, [
				trat[ind].clck,
				trat[ind].o1.pcnt,
				pt[trat[ind].o2.op],
				jmpadr,
				copy(optab[trat[ind].o1.op], 1, 6),
				tzei + sp]));
//				ad + tzei + sp]));
//	jmpadr := ad;
end;

end.
