unit simu;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Menus, StdCtrls,
	inifiles, math, ComCtrls, AppEvnts, FileCtrl;

const
// parity table
	part:    array [0..255] of boolean =
   (   false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,false,true ,true ,false,true ,false,false,true
		,true ,false,false,true ,false,true ,true ,false
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
		,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
      ,true ,false,false,true ,false,true ,true ,false
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
		,false,true ,true ,false,true ,false,false,true
      ,false,true ,true ,false,true ,false,false,true
      ,true ,false,false,true ,false,true ,true ,false
	);
	hextab: array [$30..$66] of byte =
	(	0,  1,  2,  3,  4,  5,  6, 7, 8, 9, 0, 0, 0, 0, 0, 0,
		0, 10, 11, 12, 13, 14, 15, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0,  0,  0,  0,  0,  0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 10, 11, 12, 13, 14, 15
	);

type
{$i twork.pic}

	Tsimf =
	class(TForm)
    mm: TMainMenu;
    bTrace: TButton;
    pc: TPageControl;
    tstrc: TTabSheet;
    tsser: TTabSheet;
    mseri: TMemo;
    tlb: TListBox;
    tssfr: TTabSheet;
    slb: TListBox;
    tsram: TTabSheet;
	 rlb: TListBox;
    bteins: TButton;
	 CPU1: TMenuItem;
    msero: TMemo;
    sendall: TButton;
    btstop: TButton;
    mcrlf: TCheckBox;
    Oszi1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    wait1: TMenuItem;
    w20482: TMenuItem;
    w40961: TMenuItem;
    w81921: TMenuItem;
    w163841: TMenuItem;
    w327681: TMenuItem;
    w655361: TMenuItem;
    w10241: TMenuItem;
    tathz: TMenuItem;
    Datei1: TMenuItem;
    lesen1: TMenuItem;
    schreiben1: TMenuItem;
    btpage: TButton;
    btacht: TButton;
    Button4: TButton;
    hz11: TMenuItem;
    N3: TMenuItem;
    hz12: TMenuItem;
    hz13: TMenuItem;
    hz14: TMenuItem;
    od: TOpenDialog;
    sd: TSaveDialog;
    hz10: TMenuItem;
    hz1: TMenuItem;
    hz2: TMenuItem;
    hz3: TMenuItem;
    hz4: TMenuItem;
    hz5: TMenuItem;
    hz6: TMenuItem;
    hz7: TMenuItem;
    hz9: TMenuItem;
    hz8: TMenuItem;
    sendsel: TButton;
    procedure bTraceClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tlbClick(Sender: TObject);
    procedure pcChange(Sender: TObject);
    procedure bteinsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
	 procedure sendallClick(Sender: TObject);
    procedure btstopClick(Sender: TObject);
	 procedure FormDestroy(Sender: TObject);
	 procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure schreibenClick(Sender: TObject);
    procedure Oszi1Click(Sender: TObject);
    procedure CPUClick(Sender: TObject);
    procedure waitClick(Sender: TObject);
    procedure slbClick(Sender: TObject);
    procedure rlbClick(Sender: TObject);
    procedure sendselClick(Sender: TObject);
    procedure btpageClick(Sender: TObject);
    procedure btachtClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure lesenClick(Sender: TObject);
	private		{ Private-Deklarationen }
		function 	gdadrmw(x: byte): byte;
//		procedure 	sdad(adr, wrt: byte);
		procedure 	SndByte(dat: word);
		procedure 	setfadd(o: word);
		procedure 	setfsub(o: word);
	public		{ Public-Deklarationen }
		sndp,
		sndl:			integer;
		procedure 	ssbuf(w: word);
		procedure 	ptsps(pin, mrk: byte; z: boolean);
		procedure 	ptwrt();
		procedure 	startserin;
		procedure 	Clear;
		procedure	Rini;
		procedure	Wini;
	end;

	tsndt = (stend, stwait, stbyte, stpin);

var
	wrk:			ptwork;

	simf: 		Tsimf;
	fout:			file of tpint;
	ftrc:			file of trdat;
	fdat:			integer;
	pend:			longint;
	extt:			array [0..255] of byte;
	eram:			array [0..65535] of byte;

//	ptab:			array [1..64] of boolean;
	ac:			word;
	dp:			word;
	opc:			byte;
	rel:			shortint;
	o:				ptdat;
	p:				ptrdat;
	stat:			byte;
	tsfr:			tstringlist;
	tbit:			tstringlist;
	tadr:			tstringlist;
	tram:			tstringlist;
	tlst:			tstringlist;
	rb:			integer;
	old,
	fnam:			string;
	olz:			integer;
	comv,
	comz:			longint;
	pint:			tpint;
	jmpadr:		string;
	ziffer:		set of '0'..'9' = ['0'..'9'];
	wsbuf:		word;
	trsfr:		array [128..255] of boolean;
	trram:		array [0..255] of boolean;
	trbit:		array [0..255] of boolean;

	trat:			array [0..255] of trdat;
	trai,
	trao:			integer;

procedure anzt(ind: integer);

{$i tracetab.pic}
{$i sfrdef.pic}

implementation

uses timeru, assu, oszu, assoptu;

{$R *.DFM}

function opv(): byte;
begin
	result := wrk.prog[wrk.padr];
	inc(wrk.padr);
end;

// bitadressen
function bitg(b: byte): boolean;
begin
	if b > 127
	then begin
		if wrk.sf2p[b] > 0
		then begin
			if (wrk.port[b and $F8] and (1 shl (b and $7))) > 0
			then bitg := true
			else bitg := false;
		end
		else begin
			if (wrk.sfrs[b and $F8] and (1 shl (b and $7))) > 0
			then bitg := true
			else bitg := false;
		end;
	end
	else begin
		if (wrk.iram[b div 8 + $20] and (1 shl (b and $7))) > 0
		then bitg := true
		else bitg := false;
	end;
end;

procedure pamnn;	// nix
begin
end;

{$ifdef debug}
procedure pamac;	// A
begin
	o := @p.o1;
	o.vwrt := ac;
end;

{$endif}

procedure pamda;  // iram / sfr adr
begin
	o.adr := opv();
	if o.adr > 127
	then begin
		if wrk.sf2p[o.adr] > 0
		then o.wrt := wrk.port[o.adr]
		else o.wrt := wrk.sfrs[o.adr];
	end
	else o.wrt := wrk.iram[o.adr];
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pamap;	// acc + pc
begin
	o.wadr := ac + wrk.padr;
	o.wrt := wrk.prog[o.wadr];
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pamad;	// acc + dp
begin
	o.wadr := ac + wrk.sfrs[_DPH] * 256 + wrk.sfrs[_DPL];
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pambt;	// bit adr
var
	a:			byte;
begin
	a := opv();
	if a > 127
	then begin
		if wrk.sf2p[a] > 0
		then o.wrt := byte(bitg(a)) // byte(ptab[wrk.sf2p[a]])
		else begin
			if (wrk.sfrs[a and $F8] and (1 shl (a and $7))) > 0
			then o.wrt := 1
			else o.wrt := 0;
		end;
	end
	else begin
		if (wrk.iram[a div 8 + $20] and (1 shl (a and $7))) > 0
		then o.wrt := 1
		else o.wrt := 0;
	end;
	o.adr := a;
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

{$ifdef debug}
procedure pamcc;	// C
begin
	o.vwrt := byte(wrk.bitg(_CY));
	o.vadr := o.wadr;
end;
{$endif}

procedure pamdd;	// dir dp
begin
	o.wadr := wrk.sfrs[_DPH] * 256 + wrk.sfrs[_DPL];
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pami2;	// imm 16 bit
begin
	o.wadr := opv() * 256 + opv();
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pami1;	// imm 8
begin
	o.wrt := opv();
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pamid;	// indir dp
begin
	o.wadr := wrk.sfrs[_DPH] * 256 + wrk.sfrs[_DPL];
	o.wrt := eram[o.wadr];
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pamir;	// indir reg
begin
	o.reg := (wrk.sfrs[_PSW] and $18) shl 1 + opc and $01;
	o.adr := wrk.iram[wrk.sfrs[_PSW] and $18 + opc and $01];
	o.wrt := wrk.iram[o.adr];
{$ifdef debug}
	o.vwrt := o.wrt;
{$endif}
end;

procedure pamdr;	// dir reg
begin
	o.reg := (wrk.sfrs[_PSW] and $18) shl 1 + opc and $07;
	o.adr := wrk.sfrs[_PSW] and $18 + opc and $07;
	o.wrt := wrk.iram[o.adr];
{$ifdef debug}
	o.vwrt := o.wrt;
{$endif}
end;

procedure pamnb;	// not bit adr
var
	a:			byte;
begin
	a := opv();
	if a > 127
	then begin
		if wrk.sf2p[a] > 0
		then o.wrt := byte(bitg(a)) // byte(ptab[wrk.sf2p[a]]) xor 1
		else begin
			if (wrk.sfrs[a and $F8] and (1 shl (a and $7))) > 0
			then o.wrt := 0
			else o.wrt := 1;
		end;
		o.reg := a and $F8;
		o.adr := a and $07;
	end
	else begin
		o.reg := a div 8 + $20;
		o.adr := a and $07;
		if (wrk.iram[a div 8 + $20] and (1 shl (a and $7))) > 0
		then o.wrt := 0
		else o.wrt := 1;
	end;
	o.adr := a;
{$ifdef debug}
	o.vwrt := o.wrt;
	o.vadr := o.wadr;
{$endif}
end;

procedure pamrb;	// accu B
begin
	o.wrt := wrk.sfrs[_B];
{$ifdef debug}
	o.vwrt := o.wrt;
{$endif}
end;

procedure pamsp;	// stackp
begin
end;

// set pin status
procedure Tsimf.ptsps(pin, mrk: byte; z: boolean);
var
	x:			int64;
begin
	x := int64(1 shl pin);
	if pin = 0
	then exit;
	if z
	then wrk.pmod[pin] := wrk.pmod[pin] or mrk
	else wrk.pmod[pin] := wrk.pmod[pin] and not mrk;
	case wrk.pmod[pin] of
	3, 6, 7, 9, 11, 15:
		begin // set port pin
			pint.pins := pint.pins or x;
			wrk.port[wrk.pi2s[pin] and $f8] :=
					wrk.port[wrk.pi2s[pin] and $f8] or
					(1 shl (wrk.pi2s[pin] and $07));
		end;
	else
		begin	// clr port pin
			pint.pins := pint.pins and not x;
			wrk.port[wrk.pi2s[pin] and $f8] :=
					wrk.port[wrk.pi2s[pin] and $f8] and not
					(1 shl (wrk.pi2s[pin] and $07));
		end;
	end;
end;

procedure Tsimf.ptwrt();
begin
	if not assopt.optosz.Checked
	then exit;
	pint.clck := comv - tim.iclock;
	write(fout, pint);
end;

function adra(a: integer): string;
begin
	result := tadr.Values[inttostr(a)];
	if result = ''
	then result := format('a..%4.4x', [a]);
end;

procedure sram(adr, wrt: byte);
begin
	wrk.iram[adr] := wrt;
	if trram[adr]
	then wrk.pbrk := true;
end;

procedure bitm(b: byte; z: boolean);
var
	b1: byte;
begin
	b1 := 1 shl (b and $7);
	if not z
	then b1 := b1 xor 255;
	if b > 127
	then begin
		if wrk.sf2p[b] > 0
		then begin
			if z
			then wrk.ssfr(b and $F8, wrk.sfrs[b and $F8]	or b1)
			else wrk.ssfr(b and $F8, wrk.sfrs[b and $F8] and b1);
			simf.ptsps(wrk.sf2p[b], 1, z);
			simf.ptwrt;
		end
		else begin
			if z
			then wrk.ssfr(b and $F8, wrk.sfrs[b and $F8]	or b1)
			else wrk.ssfr(b and $F8, wrk.sfrs[b and $F8] and b1);
		end;
		if trsfr[b and $F8]
		then wrk.pbrk := true;
	end
	else begin
		if z
		then sram(b div 8 + $20, wrk.iram[b div 8 + $20]  or b1)
		else sram(b div 8 + $20, wrk.iram[b div 8 + $20] and b1);
	end;
	if trbit[b]
	then wrk.pbrk := true;
end;

//direct address read mod write
function Tsimf.gdadrmw(x: byte): byte;
var
	b:		byte;
begin
	if x > 127
	then b := wrk.sfrs[x]
	else b := wrk.iram[x];
	gdadrmw := b;
end;

//procedure Tsdad(adr, wrt: byte);
procedure sdad(adr, wrt: byte);
var
	i:			integer;
	s:			boolean;
begin
	s := false;
	if adr > 127
	then begin
		wrk.ssfr(adr, wrt);
		if adr and $07 = 0
		then begin
			for i := 0 to 7
			do begin
				if wrk.sf2p[adr + i] > 0
				then begin
					s := true;
					simf.ptsps(wrk.sf2p[adr + i], 1, ((wrt shr i) and 1 = 1));
				end;
			end;
			if s then simf.ptwrt;
		end;
		if trsfr[adr]
		then wrk.pbrk := true;
	end
	else begin
		sram(adr, wrt);
	end;
end;

//set flags
procedure Tsimf.setfadd(o: word);
var
	flcy,
	flac,
	flov:		boolean;
begin
	flcy := ac + o > 255;
	flac := ac and $0f + o and $0f > 15;
	flov := ((ac and $7f + o and $7f) > 127) <> flcy;
	ac := ac + o;
	wrk.ssfr(_A, ac and $FF);
	bitm(_CY, flcy);
	bitm(_AC, flac);
	bitm(_OV, flov);
end;

procedure Tsimf.setfsub(o: word);
var
	flcy,
	flac,
	flov:		boolean;
begin
	flcy := ac < o;
	flac := ac and $0f < o and $0f;
	flov := flac <> flcy;
	ac := ac - o;
	wrk.ssfr(_a, ac and $FF);
	bitm(_CY, flcy);
	bitm(_aC, flac);
	bitm(_OV, flov);
end;

procedure code00; //NOP		amnn, amnn
begin
end;

procedure code01;	//AJMP	amnn, amnn
begin
	wrk.padr := wrk.padr and $F800 + (opc shr 5) * 256 + opv();
	p.o2.jmp := true;
end;

procedure code02; //LJMP	amnn, amnn
begin
	wrk.padr := opv() * 256 + opv();
	p.o2.jmp := true;
end;

procedure code03; //RR 		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := ac shr 1 + ac shl 7;
	p.o1.wrt := ac;
end;

procedure code04; //INC   	amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	inc(ac);
	p.o1.wrt := ac;
end;

procedure code05; //INC   	amda, amnn
begin
	o := @p.o1;
	pamda;
	inc(p.o1.wrt);
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code06; //INC		amir, amnn
begin
	o := @p.o1;
	pamir;
	inc(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code08; //INC		amdr, amnn
begin
	o := @p.o1;
	pamdr;
	inc(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code10; //JBC   	ambt, amnn
begin
	o := @p.o1;
	pambt;
	rel := opv();
	p.o2.jmp := false;
	if p.o1.wrt > 0
	then begin
		wrk.padr := wrk.padr + rel;
		bitm(p.o1.adr, false);
		p.o1.wrt := 0;
		p.o2.jmp := true;
	end;
	ac := wrk.sfrs[_A];
end;

procedure code11; //ACALL	amsp, amnn
var
	a:			word;
begin
	a := wrk.padr and $F800 + (opc shr 5) * 256 + opv();
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr);
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr shr 8);
	wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
	wrk.padr := a;
	p.o1.wrt := wrk.sfrs[_SP];
	p.o2.jmp := true;
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code12; //LCALL	amsp, amnn
var
	a:			word;
begin
	a := opv() * 256 + opv();
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr);
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], wrk.padr shr 8);
	wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
	wrk.padr := a;
	p.o1.wrt := wrk.sfrs[_SP];
	p.o2.jmp := true;
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code13; //RRC		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	if bitg(_CY)
	then ac := ac or $100;
	bitm(_CY, (ac and 1) > 0);
	ac := ac shr 1;
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure code14;	//DEC   	amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	dec(ac);
	p.o1.wrt := ac;
end;

procedure code15; //DEC   	amda, amnn
begin
	o := @p.o1;
	pamda;
	dec(p.o1.wrt);
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code16; //DEC   	amir, amnn
begin
	o := @p.o1;
	pamir;
	dec(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code18; //DEC   	amdr, amnn
begin
	o := @p.o1;
	pamdr;
	dec(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code20; //JB		ambt, amnn
begin
	o := @p.o1;
	pambt;
	rel := opv();
	if p.o1.wrt > 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code22; //RET		amsp, amnn
begin
	wrk.padr := wrk.iram[wrk.sfrs[_SP]] shl 8;
	dec(wrk.sfrs[_SP]);
	wrk.padr := wrk.padr or wrk.iram[wrk.sfrs[_SP]];
	dec(wrk.sfrs[_SP]);
	p.o1.wrt := wrk.sfrs[_SP];
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code23; //RL		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := ac shl 1 + ac shr 7;
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure code24; //ADD		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code25; //ADD		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code26; //ADDC		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code28;	//ADD		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	simf.setfadd(p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure code30;	//JNB   	ambt, amnn
begin
	o := @p.o1;
	pambt;
	rel := opv();
	p.o2.jmp := false;
	if p.o1.wrt = 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code32; //RETI	amsp, amnn
begin
	wrk.padr := wrk.iram[wrk.sfrs[_SP]] shl 8;
	dec(wrk.sfrs[_SP]);
	wrk.padr := wrk.padr or wrk.iram[wrk.sfrs[_SP]];
	dec(wrk.sfrs[_SP]);
	p.o1.wrt := wrk.sfrs[_SP];
	wrk.ints := true;
	wrk.intu[wrk.intl] := false;
	while not wrk.intu[wrk.intl] and (wrk.intl > 0)
	do dec(wrk.intl);
	pint.intl := 7;
	simf.ptwrt;
	pint.intl := 0;
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure code33; //RLC		amac, amnn
var
	flcy:		boolean;
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := ac shl 1;
	if bitg(_CY)
	then ac := ac or $01;
	flcy := (ac and $100) > 0;
	bitm(_CY, flcy);
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure code34;	//ADDC	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code35;	//ADDC	amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code36;	//ADDC	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code38;	//ADDC	amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	simf.setfadd(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code40; //JC		amcc, amnn
begin
	rel := opv();
	p.o2.jmp := false;
	if bitg(_CY)
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code42;	//ORL  	amda, amac
begin
	o := @p.o1;
	pamda;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) or ac;
	sdad(p.o1.adr, p.o1.wrt);
	p.o2.wrt := ac;
end;

procedure code43;	//ORL		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) or p.o2.wrt;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code44;	//ORL   	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code45;	//ORL		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code46; //ORL		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code48;	//ORL		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := ac or p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code50; //JNC		amcc, amnn
begin
	rel := opv();
	p.o2.jmp := false;
	if not bitg(_CY)
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure code52;	//ANL		amda, amac
begin
	o := @p.o1;
	pamda;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) and ac;
	p.o2.wrt := ac;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code53;	//ANL		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) and p.o2.wrt;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code54;	//ANL		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code55;	//ANL		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code56;	//ANL		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code58;	//ANL		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := ac and p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code60; //JZ		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	rel := opv();
	p.o2.jmp := false;
	if ac = 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
	p.o1.wrt := ac;
end;

procedure code62; //XRL		amda, amac
begin
	o := @p.o1;
	pamda;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) xor ac;
	sdad(p.o1.adr, p.o1.wrt);
	p.o2.wrt := ac;
end;

procedure code63;	//XRL		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := simf.gdadrmw(p.o1.adr) xor p.o2.wrt;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code64; //XRL		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code65; //XRL		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code66; //XRL		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code68; //XRL		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := ac xor p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code70; //JNZ		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	rel := opv();
	p.o2.jmp := false;
	if ac > 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
	p.o1.wrt := ac;
end;

procedure code72; //ORL		amcc, ambt
begin
	o := @p.o2;
	pambt;
	if p.o2.wrt > 0
	then bitm(_CY, true);
end;

procedure code73; //JMP		amad, amnn (@a+DPTR)
begin
	o := @p.o1;
	pamad;
	wrk.padr := p.o1.wadr;
	p.o2.jmp := true;
end;

procedure code74; //MOV		amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	ac := p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure code75; //MOV		amda, ami1
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pami1;
	p.o1.wrt := p.o2.wrt;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code76; //MOV		amir, ami1
begin
	o := @p.o1;
	pamir;
	o := @p.o2;
	pami1;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code78; //MOV		amdr, ami1
begin
	o := @p.o1;
	pamdr;
	o := @p.o2;
	pami1;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure code80;	//SJMP 	amnn, amnn
begin
	rel := opv();
	wrk.padr := wrk.padr + rel;
	p.o2.jmp := true;
end;

procedure code82; //ANL		amcc, ambt
begin
	o := @p.o2;
	pambt;
	bitm(_CY, ((p.o2.wrt > 0) and bitg(_CY)));
end;

procedure code83; //MOVC	amac, amap
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamap;
	ac := wrk.prog[p.o2.wadr];
	p.o1.wrt := ac;
end;

procedure code84; //DIV		amac, amrb
var
	flcy,
	flov:		boolean;
	z1,
	z2:		byte;
begin
	o := @p.o1;
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamrb;
	flcy := false;
	flov := false;
	if p.o2.wrt = 0
	then flov := true
	else begin
		z1 := ac div wrk.sfrs[_B];
		z2 := z1 * wrk.sfrs[_B];
		wrk.sfrs[_a] := z1;
		wrk.sfrs[_B] := (ac - z2);
		ac := wrk.sfrs[_a];
		p.o2.wrt := wrk.sfrs[_B];
	end;
	bitm(_CY, flcy);
	bitm(_OV, flov);
	p.o1.wrt := ac;
end;

procedure code85; //MOV		amda, amda
begin
	o := @p.o2;
	pamda;
	o := @p.o1;
	pamda;
	p.o1.wrt := p.o2.wrt;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code86; //MOV		amda, amir
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pamir;
	p.o1.wrt := p.o2.wrt;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code88; //MOV		amda, amdr
begin
	o := @p.o1;
	pamda;
	o := @p.o2;
	pamdr;
	p.o1.wrt := p.o2.wrt;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure code90; //MOV		amdd, ami2
begin
	o := @p.o2;
	pami2;
	p.o1.wadr := p.o2.wadr;
	wrk.sfrs[_DPH] := p.o1.wadr div 256;
	wrk.sfrs[_DPL] := p.o2.adr;
end;

procedure code92; //MOV 	ambt, amcc
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := byte(bitg(_CY));
	bitm(p.o1.adr, (p.o1.wrt > 0));
	ac := wrk.sfrs[_A];
end;

procedure code93;	//MOVC	amac, amad
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamad;
	ac := wrk.prog[p.o2.wadr];
	p.o1.wrt := ac;
end;

procedure code94;	//SUBB	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code95;	//SUBB	amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code96; //SUBB	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure code98; //SUBB	amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	simf.setfsub(p.o2.wrt + word(bitg(_CY)));
	p.o1.wrt := ac;
end;

procedure codeA0; //ORL		amcc, amnb
begin
	o := @p.o2;
	pamnb;
	p.o1.wrt := p.o2.wrt or byte(bitg(_CY));
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeA2; //MOV		amcc, ambt
begin
	o := @p.o2;
	pambt;
	p.o1.wrt := p.o2.wrt;
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeA3; //INC   DPTR
begin
	o := @p.o1;
	pamdd;
	inc(p.o1.wadr);
	wrk.sfrs[_DPH] := p.o1.wadr div 256;
	wrk.sfrs[_DPL] := p.o1.wadr;
end;

procedure codeA4; //MUL		amac, amrb
var
	flcy,
	flov:		boolean;
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamrb;
	flcy := false;
	ac := ac * p.o2.wrt;
	flov := ac > 256;
	wrk.sfrs[_B] := ac div 256;
	p.o2.wrt := ac div 256;
	ac := ac and $FF;
	bitm(_CY, flcy);
	bitm(_OV, flov);
	p.o1.wrt := ac;
end;

var
	ca5:	byte = $ff;
	rb5:  byte = 0;

procedure codeA5; // fr test setzen der cpu,
						// sonst nicht benutzt;
var
	i:			integer;
begin
//
	o := @p.o1;
	ca5 := ca5 xor $FF;
	rb5 := (rb5 + $008) mod 32;
	for i := 0 to 63
	do if i and 1 > 0
		then wrk.iram[i] := i xor $FF
		else wrk.iram[i] := i;
	bitm(_CY, (ca5 > 0));
	wrk.sfrs[_SP] := $5f;
	wrk.sfrs[_A] := $83;
	ac := $83;
	wrk.sfrs[_B] := $08;
	wrk.sfrs[_DPH] := opv;
	wrk.sfrs[_DPL] := opv;
	wrk.sfrs[_PSW] := rb5;
{$ifdef debug}
	o.vadr := wrk.sfrs[_DPH] * 256 + wrk.sfrs[_DPL];
	o.vwrt := wrk.sfrs[_SP];
{$endif}
	if wrk.sfrs[_DPH] + wrk.sfrs[_DPL] > 0
	then begin
		inc(wrk.sfrs[_SP]);
		wrk.iram[wrk.sfrs[_SP]] := wrk.sfrs[_DPL];
		inc(wrk.sfrs[_SP]);
		wrk.iram[wrk.sfrs[_SP]] := wrk.sfrs[_DPH];
{$ifdef debug}
		o.vwrt := wrk.sfrs[_SP];
{$endif}
	end;
//
end;

procedure codeA6; //MOV		amir, amda
begin
	o := @p.o1;
	pamir;
	o := @p.o2;
	pamda;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure codeA8; //MOV		amdr, amda
begin
	o := @p.o1;
	pamdr;
	o := @p.o2;
	pamda;
	p.o1.wrt := p.o2.wrt;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure codeB0; //ANL		amcc, amnb
begin
	o := @p.o2;
	pamnb;
	p.o1.wrt := p.o2.wrt and byte(bitg(_CY));
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeB2; //CPL		ambt, amnn
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := byte(not bitg(p.o1.adr));
	bitm(p.o1.adr, (p.o1.wrt > 0));
	ac := wrk.sfrs[_A];
end;

procedure codeB3; //CPL		amcc, amnn
begin
	p.o1.wrt := byte(not bitg(_CY));
	bitm(_CY, (p.o1.wrt > 0));
end;

procedure codeB4; //CJNE	amac, ami1
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pami1;
	rel := opv();
	if ac <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, ac < p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure codeB5; //CJNE	amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	rel := opv();
	if ac <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, ac < p.o2.wrt);
	p.o1.wrt := ac;
end;

procedure codeB6; //CJNE	amir, ami1
begin
	o := @p.o1;
	pamir;
	o := @p.o2;
	pami1;
	rel := opv();
	if p.o1.wrt <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, p.o1.wrt < p.o2.wrt);
end;

procedure codeB8; //CJNE	amdr, ami1
begin
	o := @p.o1;
	pamdr;
	o := @p.o2;
	pami1;
	rel := opv();
	if p.o1.wrt <> p.o2.wrt
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end
	else p.o2.jmp := false;
	bitm(_CY, p.o1.wrt < p.o2.wrt);
end;

procedure codeC0; //PUSH	amda, amsp
begin
	o := @p.o1;
	pamda;
{$ifdef debug}
	p.o2.vwrt := wrk.sfrs[_SP];
{$endif}
	inc(wrk.sfrs[_SP]);
	sram(wrk.sfrs[_SP], p.o1.wrt);
	wrk.spmx := max(wrk.spmx,wrk.sfrs[_SP]);
	p.o2.wrt := wrk.sfrs[_SP];
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure codeC2; //CLR		ambt, amnn
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := 0;
	bitm(p.o1.adr, false);
	ac := wrk.sfrs[_A];
end;

procedure codeC3; //CLR		amcc, amnn
begin
	bitm(_CY, false);
	p.o1.wrt := byte(bitg(_CY));
end;

procedure codeC4; //SWAP	amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := (ac shr 4 or ac shl 4) and $FF;
	p.o1.wrt := ac;
end;

procedure codeC5; //XCH		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	wrk.sfrs[_a] := p.o2.wrt;
	sdad(p.o2.adr, ac);
	p.o2.wrt := ac;
	ac := wrk.sfrs[_a];
	p.o1.wrt := ac;
end;

procedure codeC6; //XCH		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	wrk.sfrs[_a] := p.o2.wrt;
	sram(p.o2.adr, ac);
	p.o2.wrt := ac;
	ac := wrk.sfrs[_a];
	p.o1.wrt := ac;
end;

procedure codeC8; //XCH		amac, amdr
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	wrk.sfrs[_a] := p.o2.wrt;
	sram(p.o2.adr, ac);
	p.o2.wrt := ac;
	ac := wrk.sfrs[_a];
	p.o1.wrt := ac;
end;

procedure codeD0; //POP		amda, amsp
begin
	o := @p.o1;
	pamda;
{$ifdef debug}
	p.o2.vwrt := wrk.sfrs[_SP];
{$endif}
	sdad(p.o1.adr, wrk.iram[wrk.sfrs[_SP]]);
	p.o1.wrt := wrk.iram[wrk.sfrs[_SP]];
	dec(wrk.sfrs[_SP]);
	p.o2.wrt := wrk.sfrs[_SP];
	ac := wrk.sfrs[_A];
	if trsfr[_SP]
	then wrk.pbrk := true;
end;

procedure codeD2; //SETB	ambt, amnn
begin
	o := @p.o1;
	pambt;
	p.o1.wrt := 1;
	bitm(p.o1.adr, true);
	ac := wrk.sfrs[_A];
end;

procedure codeD3; //SETB	amcc, amnn
begin
	p.o1.wrt := 1;
	bitm(_CY, true);
end;

procedure codeD4; //Da		amac, amnn
var
	flcy:		boolean;
begin
{$ifdef debug}
	pamac;
{$endif}
	if bitg(_aC)
	or (ac and $0f > 9)
	then inc(ac, 6);
	flcy := ac > 256;
	if flcy
	or (ac and $f0 > $90)
	then inc(ac, $60);
	flcy := ac > 256;
	wrk.sfrs[_a] := ac;
	bitm(_CY, flcy);
	p.o1.wrt := ac;
end;

procedure codeD5; //DJNZ	amda, amnn
begin
	o := @p.o1;
	pamda;
	rel := opv();
	dec(p.o1.wrt);
	sdad(p.o1.adr, p.o1.wrt);
	if p.o1.wrt <> 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
	if p.o1.adr = _ACC
	then ac := p.o1.wrt;
end;

procedure codeD6; //XCHD	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	sram(p.o2.adr, p.o2.wrt and $F0 + ac and $0F);
	ac := p.o2.wrt and $0f + ac and $F0;
	p.o2.wrt := wrk.iram[p.o2.adr];
	p.o1.wrt := ac;
end;

procedure codeD8; //DJNZ	amdr, amnn
begin
	o := @p.o1;
	pamdr;
	rel := opv();
	p.o2.jmp := false;
	dec(p.o1.wrt);
	sram(p.o1.adr, p.o1.wrt);
	if p.o1.wrt <> 0
	then begin
		wrk.padr := wrk.padr + rel;
		p.o2.jmp := true;
	end;
end;

procedure codeE0; //MOVX	amac, amid
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamid;
	ac :=	eram[p.o2.wadr];
	p.o1.wrt := ac;
end;

procedure codeE2; //MOVX	amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := wrk.iram[p.o2.adr];
	p.o1.wrt := ac;
end;

procedure codeE4; //CLR		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o1;
	ac := 0;
	p.o1.wrt := ac;
end;

procedure codeE5; //MOV		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamda;
	ac := p.o2.wrt;
	wrk.sfrs[_a] := ac;
	p.o1.wrt := ac;
end;

procedure codeE6; //MOV		amac, amir
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamir;
	ac := p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure codeE8; //MOV		amac, amda
begin
{$ifdef debug}
	pamac;
{$endif}
	o := @p.o2;
	pamdr;
	ac := p.o2.wrt;
	p.o1.wrt := ac;
end;

procedure codeF0; //MOVX	amid, amac
begin
	o := @p.o1;
	pamid;
	eram[p.o1.wadr] := ac;
	p.o2.wrt := ac;
end;

procedure codeF2; //MOVX	amir, amac
begin
	o := @p.o1;
	pamir;
	eram[p.o1.adr] := ac;
	p.o2.wrt := ac;
end;

procedure codeF4; //CPL		amac, amnn
begin
{$ifdef debug}
	pamac;
{$endif}
	ac := ac xor $FF;
	p.o1.wrt := ac;
end;

procedure codeF5; //MOV		amda, amac
begin
	o := @p.o1;
	pamda;
	p.o2.wrt := ac;
	p.o1.wrt := ac;
	sdad(p.o1.adr, p.o1.wrt);
end;

procedure codeF6; //MOV		amir, amac
begin
	o := @p.o1;
	pamir;
	p.o2.wrt := ac;
	p.o1.wrt := ac;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure codeF8; //MOV   amdr, amac
begin
	o := @p.o1;
	pamdr;
	p.o2.wrt := ac;
	p.o1.wrt := ac;
	sram(p.o1.adr, p.o1.wrt);
end;

procedure addtrc(kenn, bit: byte);
begin
	p := @trat[trai];
	p.o1.adr := bit;
	p.o1.wrt := 1;
	p.o1.reg := kenn;
	p.o1.op := $A5;
	if wrk.ptrc
	then begin
		if assopt.opttrc.Checked
		then write(ftrc, trat[trai]);
	end;
	trai := (trai + 1) mod (high(trat) + 1);
end;

//---------------------------------------
// bearbeiten
procedure code();
begin
	if (wrk.brtr[wrk.padr] and 4 > 0)
	and wrk.ptrc
	then begin
		wrk.ptrc := false;
		addtrc($12, 0);
	end;
	if wrk.brtr[wrk.padr] and 2 > 0
	then begin
		wrk.ptrc := true;
//		jmpadr := adra(wrk.padr) + ' ';
	end;
	if wrk.padr > wrk.roms
	then begin
		wrk.pbrk := true;
	end;
	if (wrk.scom > 0)
	and (wrk.scom < comz)
	then begin
		wrk.pbrk := true;
		wrk.scom := 0;
//		wrk.scom := $78ffffff;
	end;
	p := @trat[trai];
	p.clck := comz;
	p.o1.pcnt := wrk.padr;
	opc := wrk.prog[wrk.padr];
	inc(wrk.padr);
	p.o1.op := opc;

{$ifdef debug}
	p.o1.vwrt := ac;
{$endif}
	comv := comz;
	inc(comz, wrk.clkt[opc]);

	// quelladresse und wert
	case opc of
	$00: code00;    // NOP
	$01: code01;    // AJMP
	$02: code02;    // LJMP
	$03: code03;    // RR
	$04: code04;    // INC
	$05: code05;    // INC
	$06: code06;    // INC
	$07: code06;    // INC
	$08: code08;    // INC
	$09: code08;    // INC
	$0A: code08;    // INC
	$0B: code08;    // INC
	$0C: code08;    // INC
	$0D: code08;    // INC
	$0E: code08;    // INC
	$0F: code08;    // INC
	$10: code10;    // JBC
   $11: code11;    // ACALL
   $12: code12;    // LCALL
   $13: code13;    // RRC
   $14: code14;    // DEC
   $15: code15;    // DEC
   $16: code16;    // DEC
   $17: code16;    // DEC
	$18: code18;    // DEC
   $19: code18;    // DEC
   $1A: code18;    // DEC
	$1B: code18;    // DEC
	$1C: code18;    // DEC
   $1D: code18;    // DEC
	$1E: code18;    // DEC
   $1F: code18;    // DEC
	$20: code20;    // JB
	$21: code01;    // AJMP
   $22: code22;    // RET
   $23: code23;    // RL
   $24: code24;    // ADD
   $25: code25;    // ADD
   $26: code26;    // ADD
   $27: code26;    // ADD
   $28: code28;    // ADD
   $29: code28;    // ADD
   $2A: code28;    // ADD
	$2B: code28;    // ADD
   $2C: code28;    // ADD
   $2D: code28;    // ADD
	$2E: code28;    // ADD
   $2F: code28;    // ADD
   $30: code30;    // JNB
	$31: code11;    // ACALL
   $32: code32;    // RETI
   $33: code33;    // RLC
	$34: code34;    // ADDC
   $35: code35;    // ADDC
	$36: code36;    // ADDC
	$37: code36;    // ADDC
	$38: code38;    // ADDC
   $39: code38;    // ADDC
   $3A: code38;    // ADDC
   $3B: code38;    // ADDC
   $3C: code38;    // ADDC
   $3D: code38;    // ADDC
   $3E: code38;    // ADDC
   $3F: code38;    // ADDC
   $40: code40;    // JC
   $41: code01;    // AJMP
   $42: code42;    // ORL
   $43: code43;    // ORL
	$44: code44;    // ORL
   $45: code45;    // ORL
   $46: code46;    // ORL
	$47: code46;    // ORL
   $48: code48;    // ORL
	$49: code48;    // ORL
	$4A: code48;    // ORL
   $4B: code48;    // ORL
	$4C: code48;    // ORL
   $4D: code48;    // ORL
	$4E: code48;    // ORL
	$4F: code48;    // ORL
   $50: code50;    // JNC
   $51: code11;    // ACALL
   $52: code52;    // ANL
   $53: code53;    // ANL
   $54: code54;    // ANL
   $55: code55;    // ANL
   $56: code56;    // ANL
   $57: code56;    // ANL
   $58: code58;    // ANL
   $59: code58;    // ANL
	$5A: code58;    // ANL
   $5B: code58;    // ANL
   $5C: code58;    // ANL
	$5D: code58;    // ANL
   $5E: code58;    // ANL
   $5F: code58;    // ANL
	$60: code60;    // JZ
   $61: code01;    // AJMP
	$62: code62;    // XRL
   $63: code63;    // XRL
	$64: code64;    // XRL
	$65: code65;    // XRL
	$66: code66;    // XRL
	$67: code66;    // XRL
   $68: code68;    // XRL
   $69: code68;    // XRL
   $6A: code68;    // XRL
   $6B: code68;    // XRL
   $6C: code68;    // XRL
   $6D: code68;    // XRL
   $6E: code68;    // XRL
   $6F: code68;    // XRL
	$70: code70;    // JNZ
   $71: code11;    // ACALL
   $72: code72;    // ORL
	$73: code73;    // JMP
   $74: code74;    // MOV
   $75: code75;    // MOV
	$76: code76;    // MOV
   $77: code76;    // MOV
	$78: code78;    // MOV
   $79: code78;    // MOV
   $7A: code78;    // MOV
   $7B: code78;    // MOV
	$7C: code78;    // MOV
	$7D: code78;    // MOV
   $7E: code78;    // MOV
   $7F: code78;    // MOV
   $80: code80;    // SJMP
   $81: code01;    // AJMP
   $82: code82;    // ANL
   $83: code83;    // MOVC
   $84: code84;    // DIV
	$85: code85;    // MOV
	$86: code86;    // MOV
   $87: code86;    // MOV
   $88: code88;    // MOV
	$89: code88;    // MOV
   $8A: code88;    // MOV
   $8B: code88;    // MOV
	$8C: code88;    // MOV
   $8D: code88;    // MOV
	$8E: code88;    // MOV
   $8F: code88;    // MOV
   $90: code90;    // MOV
   $91: code11;    // ACALL
   $92: code92;    // MOV
	$93: code93;    // MOVC
	$94: code94;    // SUBB
   $95: code95;    // SUBB
   $96: code96;    // SUBB
   $97: code96;    // SUBB
   $98: code98;    // SUBB
   $99: code98;    // SUBB
   $9A: code98;    // SUBB
   $9B: code98;    // SUBB
	$9C: code98;    // SUBB
   $9D: code98;    // SUBB
   $9E: code98;    // SUBB
	$9F: code98;    // SUBB
   $A0: codeA0;    // ORL
   $A1: code01;    // AJMP
	$A2: codeA2;    // MOV
	$A3: codeA3;    // INC
	$A4: codeA4;    // MUL
   $A5: codeA5;    // EXTOPC
   $A6: codeA6;    // MOV
   $A7: codeA6;    // MOV
   $A8: codeA8;    // MOV
   $A9: codeA8;    // MOV
	$AA: codeA8;    // MOV
	$AB: codeA8;    // MOV
	$AC: codeA8;    // MOV
   $AD: codeA8;    // MOV
   $AE: codeA8;    // MOV
   $AF: codeA8;    // MOV
   $B0: codeB0;    // ANL
   $B1: code11;    // ACALL
	$B2: codeB2;    // CPL
   $B3: codeB3;    // CPL
   $B4: codeB4;    // CJNE
	$B5: codeB5;    // CJNE
   $B6: codeB6;    // CJNE
   $B7: codeB6;    // CJNE
	$B8: codeB8;    // CJNE
   $B9: codeB8;    // CJNE
	$BA: codeB8;    // CJNE
   $BB: codeB8;    // CJNE
   $BC: codeB8;    // CJNE
   $BD: codeB8;    // CJNE
   $BE: codeB8;    // CJNE
   $BF: codeB8;    // CJNE
   $C0: codeC0;    // PUSH
	$C1: code01;    // AJMP
	$C2: codeC2;    // CLR
   $C3: codeC3;    // CLR
	$C4: codeC4;    // SWAP
   $C5: codeC5;    // XCH
   $C6: codeC6;    // XCH
   $C7: codeC6;    // XCH
	$C8: codeC8;    // XCH
   $C9: codeC8;    // XCH
   $CA: codeC8;    // XCH
	$CB: codeC8;    // XCH
   $CC: codeC8;    // XCH
   $CD: codeC8;    // XCH
	$CE: codeC8;    // XCH
   $CF: codeC8;    // XCH
	$D0: codeD0;    // POP
   $D1: code11;    // ACALL
   $D2: codeD2;    // SETB
   $D3: codeD3;    // SETB
   $D4: codeD4;    // DA
   $D5: codeD5;    // DJNZ
   $D6: codeD6;    // XCHD
   $D7: codeD6;    // XCHD
	$D8: codeD8;    // DJNZ
	$D9: codeD8;    // DJNZ
   $DA: codeD8;    // DJNZ
   $DB: codeD8;    // DJNZ
	$DC: codeD8;    // DJNZ
   $DD: codeD8;    // DJNZ
	$DE: codeD8;    // DJNZ
	$DF: codeD8;    // DJNZ
   $E0: codeE0;    // MOVX
	$E1: code01;    // AJMP
   $E2: codeE2;    // MOVX
   $E3: codeE2;    // MOVX
	$E4: codeE4;    // CLR
   $E5: codeE5;    // MOV
	$E6: codeE6;    // MOV
   $E7: codeE6;    // MOV
   $E8: codeE8;    // MOV
   $E9: codeE8;    // MOV
   $EA: codeE8;    // MOV
   $EB: codeE8;    // MOV
   $EC: codeE8;    // MOV
   $ED: codeE8;    // MOV
   $EE: codeE8;    // MOV
	$EF: codeE8;    // MOV
	$F0: codeF0;    // MOVX
   $F1: code11;    // ACALL
   $F2: codeF2;    // MOVX
   $F3: codeF2;    // MOVX
	$F4: codeF4;    // CPL
   $F5: codeF5;    // MOV
   $F6: codeF6;    // MOV
	$F7: codeF6;    // MOV
   $F8: codeF8;    // MOV
   $F9: codeF8;    // MOV
	$FA: codeF8;    // MOV
   $FB: codeF8;    // MOV
	$FC: codeF8;    // MOV
	$FD: codeF8;    // MOV
   $FE: codeF8;    // MOV
   $FF: codeF8;    // MOV
	end;
	ac := ac and $FF;
	wrk.sfrs[_A] := ac;
	p.o2.pcnt := wrk.padr;
	if wrk.ptrc
	then begin
		if assopt.opttrc.Checked
		then write(ftrc, trat[trai]);
		trai := (trai + 1) mod (high(trat) + 1);
	end;

	tim.tick(wrk.clkt[opc]);
	if bitg(_EA)
	then begin
		wrk.tint;
		if wrk.ibit > 0
		then begin
			pint.intl := wrk.intl * 8 + wrk.intf[wrk.intl];
			simf.ptwrt;
			pint.intl := 0;
			if wrk.ptrc
			then addtrc($11, wrk.ibit);
			wrk.ibit := 0;
		end;
	end;
	if wrk.brtr[wrk.padr] and 1 > 0
	then begin
		wrk.pbrk := true;
	end;
	p.o2.op := wrk.sfrs[_PSW];

	application.ProcessMessages;
end;

procedure anzt(ind: integer);
const
	fl = '%10d %4.4x %s %-12s %-7s %s';
	fv = '                                          %s';
	fe = '> %s';
var
	km,
	vm:		string[2];
	ad,
	sp:		string[15];
	ezei,
	tzei:	  	string[255];
{$ifdef debug}
	vzei:		string[255];
	sv:		string[15];
{$endif}
	i:			integer;
begin
	if simf.tlb.Items.count > 256
	then simf.tlb.Items.Delete(0);
	tzei := '';
	ezei := '';
{$ifdef debug}
	vzei := '';
	sv := '';
{$endif}
	km := '';
	vm := '';
	sp := '';
	for i := 0 to 2
	do begin
		if i = 0
		then o := @trat[ind].o1
		else o := @trat[ind].o2;
		case amt[trat[ind].o1.op, i] of
		amnn:					// none
			break;
		amac:					// acc
			begin
				tzei := tzei + km
								 + 'A'
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ 'A'
										+ ht[o.vwrt];
{$endif}
			end;
		amap:					// acc + pc
			begin
				tzei := tzei + km
								 + format('a+PC>0%4.4xh', [o.wadr])
								 + ht[o.wrt];
			end;
		amad:					// acc + dp
			begin
				tzei := tzei + km
								 + format('a+DP=0%4.4xh', [o.wadr]);
			end;
		ambt:					// bit adr
			begin
				tzei := tzei + km
								 + tbit[o.adr]
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ tbit[o.adr]
										+ ht[o.vwrt];
{$endif}
			end;
		amcc:					// C
			tzei := tzei + km
							 + 'C';
		amda:					// iram / sfr adr
			begin
				if o.adr > 127
				then tzei := tzei + km
								 + tsfr[o.adr]
								 + ht[o.wrt]
				else tzei := tzei + km
								 + tram[o.adr]
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then if o.adr > 127
						then vzei := vzei + km
												+ tsfr[o.adr]
												+ ht[o.vwrt]
						else vzei := vzei + km
												+ tram[o.adr]
												+ ht[o.vwrt];
{$endif}
			end;
		amdd:					// dir dp
			begin
				tzei := tzei + km
								 + format('DP=0%4.4xh', [o.wadr]);
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ format('DP=0%4.4xh', [o.vadr]);
{$endif}
			end;
		amdr:					// reg
			begin
				tzei := tzei + km
								 + format('R%2.2x', [o.reg])
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ format('R%2.2x', [o.reg])
										+ ht[o.vwrt];
{$endif}
			end;
		ameo:					// extopc bei test
			begin
				case o.reg of
{$ifdef debug}
				$10:	ezei := format('DP:0%4.4xh SP',
												[o.vadr])
								 + ht[o.vwrt];
{$endif}
				$11:	ezei := '           ' + tbit[o.adr]
								 + ht[o.wrt];
				$12:
					begin
						ezei := '--- #trace off';
						jmpadr := '';
					end;
				$13:	ezei := '       set ' + tbit[o.adr]
								 + ht[o.wrt];
				end;
			end;
		ami1:					// imm 8
			tzei := tzei + km
							 + '#'
							 + ht[o.wrt];
		ami2:					// imm 16 bit
			tzei := tzei + km
							 + format('#=0%4.4xh', [o.wadr]);
		amid:					// indir dp
			tzei := tzei + km
							 + format('DP>0%4.4xh', [o.wadr]);
		amir:					// indir reg
			begin
				tzei := tzei + km
								 + format('R%2.2x>%s', [o.reg, tram[o.adr]])
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ format('R%2.2x>0%2.2xh', [o.reg, o.adr])
										+ ht[o.vwrt];
{$endif}
			end;
		amjp:
			if trat[ind].o2.jmp
			then begin
				ad := adra(trat[ind].o2.pcnt) + ' ';
				tzei := tzei + km + ad;
			end
			else ad := '';
		amnb:					// not bit adr
			begin
				tzei := tzei + km
								 + '/'
								 + tbit[o.adr]
								 + ht[o.wrt];
{$ifdef debug}
				if i = 0
				then vzei := vzei + km
										+ '/'
										+ tbit[o.adr]
										+ ht[o.vwrt];
{$endif}
			end;
		amrb:					// accu B
			begin
				tzei := tzei + km
								 + 'B'
								 + ht[o.wrt];
{$ifdef debug}
				vzei := vzei + km
								 + 'B'
								 + ht[o.vwrt];
{$endif}
			end;
		amsp:					// stackp
			begin
				sp := vm
					+ 'SP'
					+ ht[o.wrt];
{$ifdef debug}
				sv := sv + km
							+ 'SP'
							+ ht[o.vwrt];
{$endif}
			end;
		end;
		km := ',';
		vm := ' ';
	end;
{$ifdef debug}
	if vzei > ''
	then 	simf.tlb.items.add(format(fv, [
				ad + vzei + sv]));
{$endif}
	if ezei > ''
	then begin
		simf.tlb.items.add(format(fe, [
				ezei]));
		exit;
	end;
	if copy(adra(trat[ind].o1.pcnt), 2, 2) <> '..'
	then jmpadr := adra(trat[ind].o1.pcnt)
	else jmpadr := '';
	simf.tlb.items.add(format(fl, [
				trat[ind].clck,
				trat[ind].o1.pcnt,
				pt[trat[ind].o2.op],
				jmpadr,
				copy(optab[trat[ind].o1.op], 1, 6),
				tzei + sp]));
//				ad + tzei + sp]));
//	jmpadr := ad;
end;

procedure tsimf.clear();
var
	lst:		textfile;
	tsn:		tstringlist;
	a,
	i,
	n:			integer;
	s:			string;
	c:			char;
begin
{$I-}
	closefile(fout);
	ioresult;
	closefile(ftrc);
	ioresult;
{$I+ }
	assignfile(fout, changefileext(fnam, '.pin'));
	rewrite(fout);
	assignfile(ftrc, changefileext(fnam, '.trc'));
	rewrite(ftrc);
	wrk.padr := 0;
	wrk.intl := 0;
	wrk.ints := false;
	wrk.intu[0] := false;
	wrk.intu[1] := false;
	wrk.intu[2] := false;
	wrk.intu[3] := false;
	wrk.intu[4] := false;
   pint.pins := -1;
	trai := 0;
	comz := 0;
	comv := 0;
	tim.iclock := 0;
	old := '';
	olz := 0;
	ptwrt();
	for i := low(wrk.brtr) to high(wrk.brtr)
	do begin
		wrk.brtr[i] := 0;
	end;
	for i := low(wrk.port) to high(wrk.port)
	do begin
		wrk.port[i] := 255;
	end;
	tlb.clear;
	msero.Clear;
	tbit.Clear;
//	wrk.sein := 0;
//	wrk.saus := 0;
	for i := 0 to 255
	do begin
		if i > 127
		then tbit.add(format('b..%2.2x.%d',
					[i and $F8, i mod 8]))
		else tbit.add(format('b..%2.2x.%d',
					[(i div 8 + 32), (i + 32) mod 8]));
	end;
	tsfr.Clear;
	for i := 0 to 255
	do begin
		tsfr.add(format('s..%2.2x', [i]));
	end;
	tram.Clear;
	for i := 0 to 255
	do begin
		if i < 32
		then tram.add(format('R%d%d', [(i div 8), i mod 8]))
		else tram.add(format('r..%2.2x', [i]));
	end;
	tlst.Clear;
	tadr.Clear;
	tsn := tstringlist.Create;
	if fileexists(changefileext(fnam, '.DBG'))
	then begin
		tsn.LoadFromFile(changefileext(fnam, '.DBG'));
		for i := 0 to tsn.Count - 1
		do begin
			if copy(tsn[i], 1, 1) = ';'
			then continue;
			if copy(tsn[i], 1, 1) = '['
			then continue;
			n := pos('=', tsn[i]);
			s := copy(tsn[i], n + 1, 12);
			c := s[1];
			s[1] := '$';
			a := strtoint(s);
			case c of
			'A':	tbit[a] := copy(tsn[i], 1, n - 1);
			'B':	tram[a] := copy(tsn[i], 1, n - 1);
			'C':	tadr.add(format('%d=%s', [a, copy(tsn[i], 1, n - 1)]));
			'D':	tsfr[a] := copy(tsn[i], 1, n - 1);
			'S':	wrk.brtr[a] := wrk.brtr[a] or 1;
			'T':  wrk.brtr[a] := wrk.brtr[a] or 2;
			'O':  wrk.brtr[a] := wrk.brtr[a] or 4;
			end;
		end;
		for i := 0 to 255
		do begin
			if copy(tbit[i], 2, 2) = '..'
			then begin
				if i > 127
				then tbit[i] := tsfr[i and $F8]
									+ '.'
									+ inttostr(i and $7)
				else tbit[i] := tsfr[i and $F8 div 8 + 32]
									+ '.'
									+ inttostr(i and $7);
			end;
		end;
		tadr.Sort;
		if fileexists(changefileext(fnam, '.LAS'))
		then begin
			assignfile(lst, changefileext(fnam, '.LAS'));
			reset(lst);
			while not eof(lst)
			do begin
				readln(lst, s);
				if copy(s, 4, 4) = '    '
				then break;
				if (copy(s, 9, 4) = '    ')
				or (copy(s, 11, 1) = '.')
				then continue;
				if copy(s, 14, 1) > ' '
				then begin
					tlst.add(copy(s, 9, 4)
								+ '='
								+ copy(s, 37, 255));
				end;
			end;
			closefile(lst);
		end;
		if fileexists(changefileext(fnam, '.SIN'))
		then begin
			sd.FileName := changefileext(fnam, '.SIN');
			od.FileName := sd.FileName;
			mseri.Lines.LoadFromFile(sd.FileName);
			mseri.SelStart := 0;
			mseri.SelLength := 1;
     	end;
	end;
//	tlst.SaveToFile('tlst.txt');
//	tbit.SaveToFile('tbit.txt');
//	tram.SaveToFile('tram.txt');
//	tadr.SaveToFile('tadr.txt');
//	tsfr.SaveToFile('tsfr.txt');
	tsn.Free;
	if assigned(wrk.rcpu)
	then begin
		wrk.rcpu;
	end;
	wrk.spmx := wrk.sfrs[_SP];
end;

procedure Tsimf.FormCreate(Sender: TObject);
begin
	inherited;
	tbit := tstringlist.Create;
	tsfr := tstringlist.Create;
	tram := tstringlist.Create;
	tadr := tstringlist.Create;
	tlst := tstringlist.Create;
end;

procedure Tsimf.RIni;
begin
	assf.RIniForm(Name, Self);
	assf.RIniMenu(Name, CPU1);
	assf.RIniMenu(Name, wait1);
	if fileexists(od.FileName)
	then begin
		sd.FileName := od.FileName;
		mseri.Lines.LoadFromFile(od.FileName);
		mseri.SelStart := 0;
		mseri.SelLength := 1;
	end;
end;

procedure Tsimf.WIni;
begin
	assf.WIniForm(Name, Self);
	assf.WIniMenu(Name, CPU1);
	assf.WIniMenu(Name, wait1);
end;

procedure Tsimf.ssbuf(w: word);
var
	z: double;
begin
	wrk.sfrs[_SBUF] := w;
	if mcrlf.Checked
	then begin
		wrk.bitm(_RB8, ((w and $100) > 0));
	end;
	msero.Lines.Add(format('> %3.3x %s', [w, char(w)]));
	wrk.bitm(_RI, true);
	case (wrk.sfrs[_SCON] and $C0) of
	$00: z := 16 * 9;
	$40: z := 16 * 10;
	$80,
	$C0: z := 16 * 11;
	end;
	if (wrk.sfrs[_PCON] and $80) = 0
	then z := z * 2;
	if wrk.clkt[0] < 10				// clocks NOP
	then z := z * 12;
	z := z * 100000000 / cpu1.Tag;
	wrk.scww := round(z);
//		end;
end;

procedure Tsimf.startserin();
var
	w:			longword;
	s:			string;
begin
	s := copy(mseri.text, sndp, 6) + '0000';
	if sndl < 1
	then begin
		wrk.pend := true;
		exit;
	end;
	inc(p);
//	msero.Lines.Add('###' + s);
	case s[1] of
	'\':
		begin
			case char(byte(s[2]) or $20) of
			'\':
				begin
					w := ord('\');
					inc(sndp, 2);
					dec(sndl, 2);
					ssbuf(w);
				end;
			'p':
				begin			// pin set
					w := ord(s[3]) - 48;
					if s[4] in ziffer
					then begin
						w := w * 10 + ord(s[4]) - 48;
						delete(s, 1, 1);
						inc(sndp);
						dec(sndl);
					end;
					if w > 0
					then begin
						ptsps(w, 2, (s[5] = '1'));
						if (wrk.pi2i[w] > 0)
						then wrk.bitm(wrk.pi2i[w], (s[5] = '0'));
						ptwrt;
					end
					else begin
						if s[5] = '1'
						then wrk.bitm(_P3_6, true)
						else begin
							wrk.bitm(_P3_6, false);
						end;
					end;
					msero.Lines.Add(format('pin %d=%s', [w, s[5]]));
					wrk.scww := 12;
					inc(sndp, 5);
					dec(sndl, 5);
				end;
			'w':
				begin
					if s[3] in ziffer
					then begin
						wrk.scww := wait1.tag * (byte(s[3]) - 48);
						inc(sndp);
						dec(sndl);
					end
					else wrk.scww := wait1.tag;
					if wrk.clkt[0] < 10
					then msero.Lines.Add(format('warten %d', [wrk.scww]))
					else msero.Lines.Add(format('warten %d', [wrk.scww * 12]));
					inc(sndp, 2);
					dec(sndl, 2);
				end;
			'q':
				begin
					wrk.pend := true;
					msero.Lines.Add('ende q');
				end;
			else
				begin
					w := hextab[ord(s[2])] shl 4
						 + hextab[ord(s[3])];
					inc(sndp, 3);
					dec(sndl, 3);
					if mcrlf.Checked
					then begin
						w := w shl 4 + hextab[ord(s[4])];
						inc(sndp);
						dec(sndl);
					end;
					ssbuf(w);
				end;
			end;
		end;
	#10, #13:
		begin
			inc(sndp);
			dec(sndl);
			if (s[2] = #10)
			or (s[2] = #13)
			then begin
				inc(sndp);
				dec(sndl);
			end;
			startserin;
			exit;
		end;
	';':
		begin
			if s[2] = ';'
			then begin
				w := ord(';');
				inc(sndp, 2);
				dec(sndl, 2);
				ssbuf(w);
			end
			else begin
				s := mseri.text;
				while sndl > 0
				do begin
					inc(sndp);
					dec(sndl);
					if s[sndp] >= ' '
					then continue;
					inc(sndp, 2);
					dec(sndl, 2);
					startserin;
					exit;
				end;
			end;
		end;
	else
		begin
			w := ord(s[1]);
			inc(sndp);
			dec(sndl);
			ssbuf(w);
		end;
	end;
//	s := copy(mseri.text, sndp, 5) + '0000';
//	msero.Lines.Add('***' + s);
end;

procedure Tsimf.FormClose(Sender: TObject;
			var action: TCloseaction);
begin
	action := cahide;
end;

procedure Tsimf.tlbClick(Sender: TObject);
var
	z:			word;
begin
	if (tlb.ItemIndex > -1)
	and(tlb.Items[tlb.ItemIndex][1] = ' ')
	then begin
		z := strtoint('$' + copy(tlb.Items[tlb.itemindex], 12, 4));
		assf.poslst(z);
	end;
end;

procedure Tsimf.pcChange(Sender: TObject);
var
	s:			string[255];
	i,
	j,
	l:			integer;
	o:			boolean;
	procedure rlbadd;
	begin
		if o
		then begin
			if trram[j]
			then rlb.Items.addobject('b ' + s, tobject(j))
			else rlb.Items.addobject('  ' + s, tobject(j));
		end
		else rlb.Items.add('  ' + s);
	end;
begin
	s := '';
	if pc.activePage = tssfr
	then begin
		slb.Clear;
		// sfr
		for i := 128 to 255
		do begin
			if copy(tsfr[i], 1, 3) <> 's..'
			then begin
				if trsfr[i]
				then s := 'b '
				else s := '  ';
				s := s + copy(tsfr[i] + '            ', 1, 12) + ': ';
				s := s + format('%2.2x', [wrk.sfrs[i]]);
				if i mod 8 = 0
				then begin
					s := s + format(' %d%d%d%d%d%d%d%d', [
								wrk.sfrs[i] shr 7,
								wrk.sfrs[i] shr 6 and 1,
								wrk.sfrs[i] shr 5 and 1,
								wrk.sfrs[i] shr 4 and 1,
								wrk.sfrs[i] shr 3 and 1,
								wrk.sfrs[i] shr 2 and 1,
								wrk.sfrs[i] shr 1 and 1,
								wrk.sfrs[i] and 1]);
				end;
				slb.Items.addobject(s, tobject(i));
			end;
		end;
		slb.tag := slb.items.count;
		s := '';
		for i := 128 to 255
		do begin
			if copy(tbit[i], 2, 2) <> '..'
			then begin
				s := format('  %-12s: %d', [tbit[i],
						wrk.sfrs[i and $f8] shr (i mod 8) and 1]);
				slb.Items.addobject(s, tobject(i));
			end;
		end;
	end;
	if pc.activePage = tsram
	then begin
		rlb.Clear;
		// registerbnke
		for i := 0 to 3
		do begin
			s := format('  RB%d : %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x',
							[i, wrk.iram[i * 8], wrk.iram[i * 8 + 1],
							wrk.iram[i * 8 + 2], wrk.iram[i * 8 + 3],
							wrk.iram[i * 8 + 4], wrk.iram[i * 8 + 5],
							wrk.iram[i * 8 + 6], wrk.iram[i * 8 + 7]]);
			rlb.Items.add(s);
		end;
		s := '';
		// bitadressen
		for i := 0 to 127
		do begin
			if copy(tbit[i], 2, 2) <> '..'
			then begin
				s := format('%-12s: %d', [tbit[i],
						wrk.iram[i div 8 + 32] shr (i mod 8) and 1]);
				if trbit[i]
				then rlb.Items.addobject('b ' + s, tobject(i))
				else rlb.Items.addobject('  ' + s, tobject(i));
			end;
		end;
		// byteadressen
		rlb.tag := rlb.items.count;
		s := '';
		j := 32;
		l := 0;
		o := false;
		for i := 32 to wrk.rams - 1
		do begin
			if copy(tram[i], 2, 2) <> '..'
			then begin
				l := assf.getname(tram[i]).len;
				if s > ''
				then begin
					rlbadd;
					s := '';
				end;
				s := format('%2.2x %-12s: ', [i, tram[i]]);
				o := true;
				j := i;
			end;
			if (i mod 16 = 0)	// length(s) > 41
			and (l < 1)
			then begin
				rlbadd;
				o := false;
				s := format('%2.2x %12s: ', [i, ' ']);
			end;
			dec(l);
			if l = -1
			then begin
				rlbadd;
				o := false;
				s := format('%2.2x %12s: ', [i, ' ']);
			end;
			s := s + format('%2.2x', [wrk.iram[i]]);
		end;
		if s > ''
		then begin
			rlbadd;
			o := false;
		end;
	end;
end;

procedure Tsimf.bTraceClick(Sender: TObject);
var
	i:			integer;
	clokz:		longint;
	timea,
	timee,
	timez:		double;
begin
	wrk.pbrk := false;
	wrk.pstp := false;
	wrk.pend := false;
	timea := time;
	clokz := comz;
	ptwrt;
	while not wrk.pbrk
	and not wrk.pstp
	and not wrk.pend
	do begin
//		assf.poslst(wrk.padr);
		code();
//		application.ProcessMessages;
	end;
	timee := time + 0.00000000001;
	timez := (timee - timea) * 24 * 60 * 60;
	clokz := (comz - clokz) div 1000000;

	tathz.Caption:= format('(%.3f %.0f)',
			[timez, int(clokz / timez)]);
	for i := 0 to 255
	do begin
		trao := (trai + i) mod 256;
		anzt(trao);
	end;
	if wrk.pend
	then begin
		tlb.items.add('> --- ende si');
		msero.Lines.Add('-ende si');
	end;
	if wrk.pbrk
	then begin
		tlb.items.add('> --- #break');
		msero.Lines.Add('#break');
	end;
	if wrk.pstp
	then begin
		tlb.items.add('> --- stop');
		msero.Lines.Add('-stop');
	end;
	tlb.TopIndex := max(0,tlb.items.Count - 20);
	pcchange(self);
	ptwrt;
	closefile(fout);
	assignfile(fout, changefileext(fnam, '.pin'));
	reset(fout);
	seek(fout, filesize(fout));
end;

procedure Tsimf.bteinsClick(Sender: TObject);
var
	i,
	j:			integer;
	s:			boolean;
begin
//	assf.poslst(wrk.padr);
	s := wrk.ptrc;
	wrk.ptrc := true;
	i := trai;
	code();
	j := i;
	while j <> trai
	do begin
		anzt(j);
		j := (j + 1) mod (high(trat) + 1);
	end;
	tlb.TopIndex := max(0,tlb.items.Count - 20);
	wrk.ptrc := s;
	pcchange(self);
	ptwrt;
	closefile(fout);
	assignfile(fout, changefileext(fnam, '.pin'));
	reset(fout);
	seek(fout, filesize(fout));
end;

procedure Tsimf.FormActivate(Sender: TObject);
begin
	if assopt.optosz.Checked
	then oszi1.Enabled := true
	else oszi1.Enabled := false;
	if simf.Tag > 0
	then exit;
//	com.addports(port1);
//	com.mon := msero;
	simf.tag := 1;
end;

procedure Tsimf.btstopClick(Sender: TObject);
begin
	wrk.pstp := true;
	pcchange(self);
end;

procedure Tsimf.FormDestroy(Sender: TObject);
begin
	tbit.Free;
	tsfr.Free;
	tram.Free;
	tadr.Free;
	tlst.Free;
	inherited;
end;

procedure Tsimf.SndByte(dat: word);
var
	c:			char;
begin
	if (dat >= $20)
	and (dat <= $80)
	then c := char(dat)
	else c := '.';
	msero.lines.Add(format('%3.3x %s >', [dat, c]));
end;

procedure Tsimf.FormShow(Sender: TObject);
begin
	pc.ActivePage := tsser;
	wrk.bitg := bitg;
	wrk.bitm := bitm;
	wrk.atrc := addtrc;
	wrk.sbyt := sndbyte;

	if assf.pc0fnam.Caption > ''
	then fnam := assf.pc0fnam.caption
	else if assf.pc1fnam.caption > ''
		then fnam := assf.pc1fnam.caption;
	simf.Clear;
	if fileexists(od.FileName)
	then begin
		sd.FileName := od.FileName;
		mseri.Lines.LoadFromFile(od.FileName);
	end
	else mseri.Clear;
	wrk.ptrc := true;
	mseri.SelStart := 0;
	mseri.SelLength := 0;
end;

procedure Tsimf.FormHide(Sender: TObject);
begin
	oszf.Hide;
	assf.show;
end;

procedure Tsimf.schreibenClick(Sender: TObject);
begin
	mseri.SelStart := 1;
	mseri.SelLength := 0;
	sd.InitialDir := extractfilepath(fnam);
	if sd.Execute
	then begin
		mseri.Lines.SaveToFile(sd.FileName);
	end;
end;

procedure Tsimf.lesenClick(Sender: TObject);
begin
	od.InitialDir := extractfilepath(fnam);
	sd.InitialDir := od.InitialDir;
	if od.Execute
	then begin
		mseri.Lines.LoadFromFile(od.FileName);
		sd.FileName := od.FileName;
		mseri.SelStart := 1;
		mseri.SelLength := 0;
	end;
end;

procedure Tsimf.Oszi1Click(Sender: TObject);
begin
	oszf.show;
end;

procedure Tsimf.CPUClick(Sender: TObject);
begin
	cpu1.caption := tmenuitem(Sender).caption;
	cpu1.tag := tmenuitem(Sender).tag;
	tmenuitem(Sender).checked := true;
end;

procedure Tsimf.waitClick(Sender: TObject);
begin
	with sender as tmenuitem
	do begin
		checked := true;
		wait1.caption := caption;
		wait1.tag := tag;
	end;
end;

procedure Tsimf.slbClick(Sender: TObject);
var
	i:			integer;
begin
	if slb.itemindex = -1
	then exit;
	i := integer(slb.items.Objects[slb.ItemIndex]);
	if i < 0
	then exit;
	if copy(slb.Items[slb.ItemIndex], 1, 1) = 'b'
	then begin
		slb.Items[slb.ItemIndex] :=
			' ' + copy(slb.Items[slb.ItemIndex], 2, 80);
		if slb.ItemIndex < slb.tag
		then trsfr[i] := false
		else trbit[i] := false;
	end
	else begin
		slb.Items[slb.ItemIndex] :=
			'b' + copy(slb.Items[slb.ItemIndex], 2, 80);
		if slb.ItemIndex < slb.tag
		then trsfr[i] := true
		else trbit[i] := true;
	end;
end;

procedure Tsimf.rlbClick(Sender: TObject);
var
	i:			integer;
begin
	if rlb.itemindex = -1
	then exit;
	i := integer(rlb.items.Objects[rlb.ItemIndex]);
	if i < 0
	then exit;
	if copy(rlb.Items[rlb.ItemIndex], 1, 1) = 'b'
	then begin
		rlb.Items[rlb.ItemIndex] :=
			' ' + copy(rlb.Items[rlb.ItemIndex], 2, 80);
		if rlb.ItemIndex < rlb.tag
		then trbit[i] := false
		else trram[i] := false;
	end
	else begin
		rlb.Items[rlb.ItemIndex] :=
			'b' + copy(rlb.Items[rlb.ItemIndex], 2, 80);
		if rlb.ItemIndex < rlb.tag
		then trbit[i] := true
		else trram[i] := true;
	end;
end;

procedure Tsimf.sendallClick(Sender: TObject);
begin
	if sd.FileName = ''
	then lesenclick(lesen1)
	else mseri.Lines.SaveToFile(sd.FileName);
	clear;
	mseri.SelStart := 0;
	sndp := 1;
	sndl := length(mseri.text);
	startserin;
end;

procedure Tsimf.sendselClick(Sender: TObject);
var
   p,
   l: integer;
begin
	sndp := mseri.SelStart;
	sndl := mseri.SelLength;
   p := sndp;
   l := sndl;
   clear;
	startserin;
	mseri.SelStart := p;
	mseri.SelLength := l;
end;

procedure Tsimf.btpageClick(Sender: TObject);
var
	i,
	j,
	k:			integer;
	s:			boolean;
begin
//	assf.poslst(wrk.padr);
	s := wrk.ptrc;
	wrk.ptrc := true;
	i := trai;
	k := msero.Height div (abs(msero.Font.Height) + 2);
	for k := k downto 2
	do	code();
	j := i;
	while j <> trai
	do begin
		anzt(j);
		j := (j + 1) mod (high(trat) + 1);
	end;
	tlb.TopIndex := max(0,tlb.items.Count - 20);
	wrk.ptrc := s;
	pcchange(self);
	ptwrt;
	closefile(fout);
	assignfile(fout, changefileext(fnam, '.pin'));
	reset(fout);
	seek(fout, filesize(fout));
end;

procedure Tsimf.btachtClick(Sender: TObject);
var
	i,
	j,
	k:			integer;
	s:			boolean;
begin
//	assf.poslst(wrk.padr);
	s := wrk.ptrc;
	wrk.ptrc := true;
	i := trai;
	for k := 7 downto 0
	do	code();
	j := i;
	while j <> trai
	do begin
		anzt(j);
		j := (j + 1) mod (high(trat) + 1);
	end;
	tlb.TopIndex := max(0,tlb.items.Count - 20);
	wrk.ptrc := s;
	pcchange(self);
	ptwrt;
	closefile(fout);
	assignfile(fout, changefileext(fnam, '.pin'));
	reset(fout);
	seek(fout, filesize(fout));
end;

procedure Tsimf.Button4Click(Sender: TObject);
begin
	if button4.Tag = 0
	then begin
		button4.Tag := 1;
		button4.Caption := 'Steuerung';
		sendall.Enabled := false;
		sendsel.Enabled := false;
		mseri.Clear;
		mseri.Font.Style := [];
		mseri.Lines.Add('\w[n]    n Einheiten clocks ausfhren');
		mseri.Lines.Add('         1 Einheit: siehe Menu w=');
		mseri.Lines.Add('\pn=0/1  set pin');
		mseri.Lines.Add('         pin 0 = comparator output');
		mseri.Lines.Add('\xx      hex');
		mseri.Lines.Add('\0xx');
		mseri.Lines.Add('\1xx     hex 9 bit');
		mseri.Lines.Add(';        Bemerkung bis Zeilenende');
		mseri.Lines.Add('\q       ende der eingabe');
		mseri.Lines.Add('\\       Eingabe \');
		mseri.Lines.Add(';;       Eingabe ;');
		mseri.Lines.Add('');
		mseri.Lines.Add('alles andere ist Eingabetext');
		mseri.Lines.Add('cr/lf werden nicht bercksichtigt und');
		mseri.Lines.Add('werden mit \0d und \0a eingeben ');
	end
	else begin
		button4.Tag := 0;
		button4.Caption := 'Legende';
		mseri.Font.Style := [fsunderline];
		sd.FileName := changefileext(fnam, '.SIN');
		od.FileName := sd.FileName;
		mseri.Lines.LoadFromFile(sd.FileName);
		mseri.SelStart := 1;
		mseri.SelLength := 0;
		sendall.Enabled := true;
		sendsel.Enabled := true;
	end;
end;

end.

